package ru.jimbot.modules.chat;

/**
 *  
 * @modification ~Jo-MA-Jo~
 */

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import ru.jimbot.modules.GorodaExtend;
import ru.jimbot.protocol.IcqProtocol;
import java.util.LinkedHashSet;
import java.util.Random;


public class Goroda {
private HashMap<String, GorodaExtend> gor;
public ChatServer srv;
public ChatProps psp;


    public Goroda(ChatServer srv){
    this.srv = srv;
    psp = ChatProps.getInstance(this.srv.getName());
    gor = new HashMap<String, GorodaExtend>();
    }



    /**
     *   
     * @param uin
     * @return
     */

    public boolean ayy(String uin){
    return gor.containsKey(uin);
    }


    /**
     *  
     * @param proc
     * @param uin
     * @param msg
     */

    public void parse(IcqProtocol proc, String uin, String msg, String NICK){


         long time = psp.getIntProperty("goroda_time") * 60000;
         int ball = 0;
         int ball_gor =psp.getIntProperty("goroda_ball");
         Users uss = srv.us.getUser(uin);
         boolean n=false;
         LinkedHashSet ignor = new LinkedHashSet();

       if(!gor.containsKey(uin)&&msg.length()>0){
           n=true;
           gor.put(uin, new GorodaExtend(uin,msg,ball,time,ignor));
           }

        if (!n&&!gor.containsKey(uin)){
                    int id = getRandom();
                    String ity = getity(id);
                    proc.mq.add(uin, NICK+" ->>\n"+
                                               "  "+uss.localnick+" :)  ...\n" +
                                               "    [ "+ity+" ]\n" +
                                               "  ,     [ "+getLastSimvol(ity)+" ]\n"+
                                               " ---------\n"+
                                               "    - "+psp.getIntProperty("goroda_time")+".");


                    gor.put(uin, new GorodaExtend(uin,ity,ball_gor,time,ignor));
                    gor.get(uin).adignor(ity);
        }else{

                      String Cb = gor.get(uin).getgorod(); // 
                      String Cu =  msg; // 
              if (msg.equalsIgnoreCase("/")){
                       proc.mq.add(uin, NICK+" ->>"+"*BYE*  !");
                       gor.remove(uin);
                       return;
                      }
              if (!testityB(msg)&&!n){
                       proc.mq.add(uin, NICK+" ->>"+" *NO*   !  *PARDON*"+getHistory(uin));
                       gor.remove(uin);
                       return;
                      }
              if (!gor.get(uin).istime()&&!n){
                       proc.mq.add(uin, NICK+" ->>"+"  ! *PARDON*"+getHistory(uin));
                       gor.remove(uin);
                       return;
                      }
              if (testignor(msg,uin)&&!n){
                       proc.mq.add(uin, NICK+" ->>"+" *NO*    !\n :)");
                  //     gor.remove(uin);
                       return;
                      }

              if  (tstCity(Cb,Cu)||n){
                    ball = gor.get(uin).getball()+ball_gor;
                    gor.get(uin).adignor(msg.toLowerCase());
                    String ity = getity(getLastSimvol(msg),uin);
                if (ity.equals("?")){
                       proc.mq.add(uin, NICK+" ->>\n"+
                                                  " ..*SCRATCH*    \n" +
                                                  " *BRAVO* ,   : "+ball+" "+psp.getStringProperty("valuta.chat")+getHistory(uin));
                       uss.ball=uss.ball+ball;
                       srv.us.updateUser(uss);
                       gor.remove(uin);
                       return;
                      }
                    gor.get(uin).adignor(ity.toLowerCase());
                    String t=" ..*SCRATCH* ,    "+ball_gor+" "+psp.getStringProperty("valuta.chat")+
                             " : "+ball+"$\n" ;
                    if (n)t=" ..*SCRATCH*    ["+msg+"]\n" ;
                    proc.mq.add(uin, NICK+" ->>\n"+t+
                                               "       [ "+getLastSimvol(msg)+" ]\n" +
                                               " ---------\n"+
                                               "  [ "+ity+" ]      [ "+getLastSimvol(ity)+" ]\n" +
                                               " ---------\n"+
                                               "    - "+psp.getIntProperty("goroda_time")+".\n"+
                                               " / -   ");

                    gor.put(uin, new GorodaExtend(uin,ity,ball,time,gor.get(uin).getignor()));
                    }

                   }

    }

  private String getHistory(String uin) {
   String nh="\n :\n";
   String h="";
   try{
   int n=0;
    Set<String> city = gor.get(uin).getignor();
       for (String a : city){
       h+=a+" -> ";
       n++;
       }
       if (n>0)h=nh+h+"\n : "+n+" .";
   } catch (Exception ex){}
  return h;
   }

    /**
     *    (  - -   )
     * @return
     */
      private int getRandom() {
           Random r = new Random();
           int max = (int)srv.us.db.getLastIndex("weather");
      return r.nextInt(max);
     }


      /**
       *    id
       * @param id
       * @return
       */
     private String getity(int id) {
        String ity = "";
        try {
             PreparedStatement pst =  (PreparedStatement) srv.us.db.getDb().prepareStatement("select * from weather where id=" + id);
             ResultSet rs = pst.executeQuery();
           if(rs.next()){
              ity = rs.getString(3);
           }
             rs.close();
             pst.close();
           } catch (Exception ex){}
     return ity;
    }

   /**
    *        
    * @param simvol
    * @param uin
    * @return
    */

  private String getity(String simvol,String uin) {

   String c="?";
    Set<String> city = getlistity(simvol,uin);
       for (String a : city){
        if(!testignor(a,uin)) c= a;
        break;
       }

  return c;
   }

  /**
   *       
   * @param simvol
   * @param uin
   * @return
   */
  private Set<String> getlistity(String simvol,String uin) {
     Set<String> city = new HashSet();
   try {//SELECT txt FROM weather WHERE txt LIKE '%';
       PreparedStatement pst = srv.us.db.getDb().prepareStatement("SELECT txt FROM weather WHERE txt LIKE '"+simvol+"%';");
       ResultSet rs = pst.executeQuery();
     while(rs.next()){
               city.add(rs.getString(1));
   }
   rs.close();
   pst.close();
   } catch (Exception ex){}
   //   Log.info("getlistity  "+city.toString());
   return city;
   }

 /**
  *    
  * @param w
  * @param uin
  * @return
  */
    private boolean testignor(String w,String uin) {
    return gor.get(uin).isignor(w.toLowerCase());
   }

      private String getFirstSimvol(String w) {
            return w.substring(0, 1).toUpperCase();// 
         }
  /**
   *     ,       
   * @param w
   * @return
   */
       private String getLastSimvol(String w) {
           int pos = w.length() - 1;
           String lastChar=w.substring(pos,pos+1).toUpperCase();
         if (w.toUpperCase().charAt(pos) == '') {
            return "";
           }
         else if (lastChar.equals("")|| lastChar.equals("") || lastChar.equals("")) {
         pos--;
         }
           return w.substring(pos,pos+1).toUpperCase();
         }

   /**
    *       
    * @param text
    * @return
    */

    private boolean testityB(String text)
   {

    boolean b=false;
    try{
        PreparedStatement pst = srv.us.db.getDb().prepareStatement("SELECT `num` FROM `weather` WHERE `txt` = ? ");
         pst.setString(1,text);
         ResultSet rs = pst.executeQuery();
         if(rs.next())
             b =true;
          else
             b =false;
            rs.close();
            pst.close();

    }catch (Exception ex){}
     return b;

    }


      /**
       *     
       * @param Cityb
       * @param City
       * @return
       */
     private boolean tstCity(String Cityb,String City)

       {
        boolean b =false;
        try{
       // String ss = Cityb.substring(Cityb.length()-1, Cityb.length()).toUpperCase();// 
       // String ss2 = City.substring(0, 1).toUpperCase();// 
        String ss = getLastSimvol(Cityb);// 
        String ss2 =  getFirstSimvol(City);// 
        b=(ss.equals(ss2));
        } catch (Exception ex){b =false;}
        return  b;
      }


}