
package ru.jimbot.modules.chat;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.Arrays;
import java.util.Collections;
import java.util.Enumeration;
import java.util.List;
import java.util.Random;
import java.util.Vector;
import java.util.concurrent.ConcurrentHashMap;
import ru.jimbot.util.Log;

/**
 *   " "
 * @author Kornackii ALexsandr (fraer72) by Warik777
 */

public class GuessTheWord implements Runnable {
public String NICK = "";
private ChatServer srv;
private ChatProps psp;
private int sleepAmount = 1000;
public Thread th;
private ConcurrentHashMap <Integer, WordGameInfo> wordinfo;
private static Random R;
private Random r = new Random();
private int count = 0;
/*  */
static {
R = new Random(System.nanoTime());
}

private boolean wordStart = true;
private boolean autofilling = true;
public boolean isStart = false;

/* */
public GuessTheWord(ChatServer s){
srv = s;
psp = ChatProps.getInstance(srv.getName());
wordinfo = new ConcurrentHashMap<Integer, WordGameInfo>();
}

/*,   */
private class WordGameInfo {
public int id = 0;
public int room = 0;
public long time = 0;
public String word;
public String answer;
public char[] mix;
public int starsCount;
public boolean start = true;

WordGameInfo(int id, int room, long time, String word, String answer) {
this.id = id;
this.room = room;
this.time = time;
this.word = word;
this.answer = answer;
}
}


/**
 *  
 */
private void wordStart(){
String[] rooms = psp.getStringProperty("word.room").split(";");
for(int i = 0;i < rooms.length; i++){
String m = getWord();
WordGameInfo word = new WordGameInfo(i, Integer.parseInt(rooms[i]), System.currentTimeMillis(), getWord(m), m);
count++;
wordinfo.put(i, word);
}
}

private void word(){
/* */
if(autofilling)
if(getCountQuestion() == 0){
Log.debug("    .  \"Guess word\"  !");
autofilling = false;
stop();
return;
}
/*   ?*/
if(!TestCountChat())return;
if(wordStart){
String s = psp.getStringProperty("word.room");
if(s.equals("")){
Log.error("      !");
return ;//      
} else {
//   
wordStart = false;
autofilling = false;
wordStart();
}
}
//  
for(int id = 0;id < count; id++){
WordGameInfo word = wordinfo.get(id);
if((System.currentTimeMillis() - word.time)>psp.getIntProperty("word.time")){
word.time = System.currentTimeMillis();//   
Question(word.id); // 
}
}
}

/**
*  ,     
* @param id - id 
* @param room - 
*/
private void Question(int id){
WordGameInfo word = wordinfo.get(id);
if(word.start)Hint(word.answer, id);
//    
if(hasStars(id)){
replaceOne(id);//   
String help = String.valueOf(getMix(id));
String g_1 =  NICK+ ": " + getFraza()+'\n'+
": "+ word.word +
(!psp.getBooleanProperty("word.help.on.off") ? ("") : "\n: ''" + help +"''");
srv.cq.addMsg(g_1, "", word.room);
word.time = System.currentTimeMillis();
word.start = false;
wordinfo.put(id, word);
}else{
//    
String g_2 = "    !";
srv.cq.addMsg(g_2, "", word.room);
String m = getWord();
word.word = getWord(m);
word.answer = m;
word.time = System.currentTimeMillis();
word.start = true;
wordinfo.put(id, word);
}
}

public String getFraza(){
String[] s = {
"   ,      .",
"        ,    .",
"         ,    .",
"       ,    .",
"   ,    ,     ,    .",
"        ,    .",
"          ,    ."
};
return s[getRND(s.length)];
}

public int getRND(int i){
return r.nextInt(i);
}

/**
*  ,   
* @param uin -  
* @param room - 
*/
public void Answer(String uin, int room){
int id = getWordId(room);// id 
WordGameInfo word = wordinfo.get(id);
srv.us.getUser(uin).ball += psp.getIntProperty("word.ball");//    :)
srv.us.getUser(uin).answer += 1;
srv.us.updateUser(srv.us.getUser(uin));
srv.cq.addMsg(
",  " + srv.us.getUser(uin).localnick +" ["+srv.us.getUser(uin).id +"]\n" +
"()  ''" + word.answer + "''" +
"\n() ()   "+ srv.us.getUser(uin).answer +" .\n" +"", "", room);
String m = getWord();
word.word = getWord(m);
word.answer = m;
word.time = System.currentTimeMillis();
word.start = true;
wordinfo.put(id, word);
Question(id);
}


/**
*  
* @param msg -  
* @param room - 
* @return
*/
public boolean TestOtvet(int room, String msg){
int id = getWordId(room);// id 
WordGameInfo word = wordinfo.get(id);
String[] mmsg = msg.split(" ");
String answer = mmsg[0].toLowerCase();
return answer.trim().equals(word.answer.toLowerCase());
}


/**
*     
* @param room - 
* @return
*/
private int getWordId(int room){
int id_word = 0;
for(int id = 0;id < count; id++){
WordGameInfo word = wordinfo.get(id);
if(word.room == room){
id_word = word.id;
}
}
return id_word;
}

/**
*  
* @param uin -  
* @param mmsg - 
* @param room - 
*/
public void parse(String uin, String mmsg, int room) {
if(getCountQuestion() == 0)return;//   
if(TestOtvet(room, mmsg) && TestRoom(room)) Answer(uin,room);
}

/**
*    ?
* @param room - 
* @return
*/
public boolean TestRoom(int room) {
try{
String s = psp.getStringProperty("word.room");
if(s.equals("")) return false;
String[] rooms = s.split(";");
for(int i=0;i<rooms.length;i++){
if(Integer.parseInt(rooms[i]) == room) return true;
}
} catch(Exception ex){
ex.printStackTrace();
}
return false;
}

public void start(){
th = new Thread(this);
th.setPriority(Thread.NORM_PRIORITY);
th.start();
}

public synchronized void stop(){
th = null;
notify();
}

public void run(){
Thread me = Thread.currentThread();
while (th == me){
word();
try {
Thread.sleep(sleepAmount);
}catch (InterruptedException e){
break;
}
}
th=null;
}


/**
*  
* @param id
* @return
*/
private String getWord(){
String word = "";
try {
PreparedStatement pst = (PreparedStatement) srv.us.db.getDb().prepareStatement("select * from victorina ORDER BY RAND( ) LIMIT 0 , 1");
ResultSet rs = pst.executeQuery();
if(rs.next())
word += rs.getString(3);
rs.close();
pst.close();
} catch (Exception ex) {}
return word;
}

public void AddWord(int id, String question, String answer){
try{
PreparedStatement pst = (PreparedStatement) srv.us.db.getDb().prepareStatement("insert into victorina values (?, ?,?)");
pst.setInt(1,id);
pst.setString(2,question);
pst.setString(3,answer);
pst.execute();
pst.close();
} catch (Exception ex){
ex.printStackTrace();
}
}

/**
*   
* @return
*/
private int getCountQuestion(){
String q = "SELECT count(*) FROM `victorina` WHERE id";
Vector<String[]> v = srv.us.db.getValues(q);
return Integer.parseInt(v.get(0)[0]);
}

/**
*  
* @param word
* @return
*/
private String getWord(String word){
String rndword ="";
Character[] w = new Character[word.length()];
for (int i=0;i<word.length();i++)
w[i] = word.charAt(i);
List<Character> list = Arrays.asList(w);
Collections.shuffle(list);
for (int j=0;j<list.size();j++)
rndword+=list.get(j);
return rndword;
}

/**
*     ,     
* @return false -      
*/
private boolean TestCountChat(){
int cnt=0;
Enumeration<String> e = srv.cq.uq.keys();
while(e.hasMoreElements()){
String i = e.nextElement();
Users us = srv.us.getUser(i);
if(us.state==UserWork.STATE_CHAT){
cnt++;
}
}
if((cnt) == 0){
return false;
}
return true;
}

/**
*  
* @param word
* @param id - id 
*/
private void Hint(String words, int id){
WordGameInfo word = wordinfo.get(id);
word.answer = words;
word.starsCount = words.length();
word.mix = new char[word.starsCount];
Arrays.fill(word.mix, '*');
}

/**
*   
* @param id - id 
*/
private void replaceOne(int id){
WordGameInfo word = wordinfo.get(id);
if (word.starsCount == 0) return;
int nextStarIndex = R.nextInt(word.starsCount);
for (int i = 0; i < word.mix.length; i++){
if (word.mix[i] == '*'){
if (nextStarIndex-- == 0){
  word.mix[i] = word.answer.charAt(i);
break;
}
}
}
word.starsCount--;
}

/**
*     
* @param id - id 
* @return
*/
private char[] getMix(int id){
WordGameInfo quiz = wordinfo.get(id);
return quiz.mix;
}

/**
*    
* @param id - id 
* @return
*/
public boolean hasStars(int id){
WordGameInfo quiz = wordinfo.get(id);
return quiz.starsCount != 1 && quiz.starsCount != 0;
}

/**
*  
* @param start
*/
public void setStart(boolean start){
isStart = start;
}

/**
*  
* @return
*/
public boolean isStart(){
return isStart;
}

/**
*              
* @param room
* @return
*/
public String getAnswer(int room){
int id = getWordId(room);// id 
WordGameInfo quiz = wordinfo.get(id);
return quiz.answer;
}

/**
*    
* @param room
*/
public void addWord(int room){
String rooms = psp.getStringProperty("word.room");
if(rooms.equals("")){
psp.setStringProperty("word.room", Integer.toString(room));
psp.save();
}else{
psp.setStringProperty("word.room", ";" + Integer.toString(room));
psp.save();
}
String m = getWord();
WordGameInfo word = new WordGameInfo(count, room, System.currentTimeMillis(), getWord(m), m);
wordinfo.put(count, word);
count++;
}

}
