/**
 * JimBot - Java IM Bot
 * Copyright (C) 2010 JimBot project
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package ru.jimbot.modules.chat;

import java.util.Vector;
import java.util.HashMap;
import ru.jimbot.Manager;
import ru.jimbot.modules.Cmd;
import ru.jimbot.protocol.IcqProtocol;
import ru.jimbot.modules.CommandParser;
import ru.jimbot.modules.CommandExtend;
import ru.jimbot.util.MainProps;

/**
 *  
 *  ChatCommandProc
 *
 * public Help help;
 *
 * help = new Help(this);
 *
 *  
 * if(help.commandHelp(proc, uin, mmsg)) return;
 *
 * @author Warik777
 * @author dimax
 * @author Static
 */

public class Help {
private HashMap<String, Cmd> commands = new HashMap<String, Cmd>();
private CommandParser parser;
private ChatCommandProc cmd;
private HashMap<String, CommandExtend> helpMap;
public ChatServer srv;
/**Creates a new instance of Help*/
public Help(ChatCommandProc c) {
parser = new CommandParser(commands);
cmd = c;
helpMap = new HashMap<String, CommandExtend>();
init();
}

private void init() {
commands.put("!help", new Cmd("!help","",1));
commands.put("!", new Cmd("!", "", 1));
commands.put("!", new Cmd("!", "", 1));
}
public boolean addCommand(String name, Cmd c) {
boolean f = commands.containsKey(name);
commands.put(name, c);
return f;
}
public boolean commandHelp(IcqProtocol proc, String uin, String mmsg) {
String tmsg = mmsg.trim();
int tp = 0;
if(helpMap.containsKey(uin))
if(!helpMap.get(uin).isExpire())
tp = parser.parseCommand(helpMap.get(uin).getCmd());
else {
tp = parser.parseCommand(tmsg);
helpMap.remove(uin);
}else
tp = parser.parseCommand(tmsg);

int tst=0;
if(tp<0)
tst = 0;
else
tst = tp;
boolean f = true;
switch (tst) {
case 1:
cHelp(proc, uin, mmsg);
break;

default:
f = false;
break;
}
return f;
}


//
/**
 *  
 *   dim@xa
 * @param proc
 * @param uin
 * @param mmsg
 * @author StaTi
 * @rewrite dim@X
 */
public void cHelp(IcqProtocol proc, String uin, String mmsg){
try{

MainProps.ObTextService(cmd.srv.getName());
//MainProps.AddTextService(cmd.srv.getName());
//MainProps.admin_msg(cmd.srv.getName());
//MainProps.CopyingHelp(cmd.srv.getName(), "chat");
//MainProps.CopyingText(cmd.srv.getName(), "chat");

    String categ = cmd.psp.getStringProperty("help.id");
String categtxt = cmd.psp.getStringProperty("categori.txt");
String helptxt = cmd.psp.getStringProperty("help.txt");
String exthelp = cmd.psp.getStringProperty("exthelp");
String[] ss = categ.split(";"); //help id
String[] ss1 = categtxt.split(";"); //
String[] ss2 = helptxt.split(";"); //
String[] ss3 = exthelp.split(";"); //

String k01 = cmd.psp.getStringProperty("help.show");





    String[] s ;
    String List = ":\n";
int step = 0; //
String cm = ""; //
Vector v1 = new Vector(); // 
if (helpMap.containsKey(uin)){
step = Integer.parseInt(helpMap.get(uin).getMsg()); //      
cm = helpMap.get(uin).getCmd(); // ,     .. 
v1 = helpMap.get(uin).getData();
}
switch (step){
case 0: //  

for(int i=0;i<ss.length;i++){

List +=  ss[i]+ k01 +ss1[i]+"\n";
}
proc.mq.add(uin,List+"   [0]");
helpMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,60000));
break;

case 1: //  
for(int i1=0;i1<ss.length;i1++){
  for(int i2=0;i2<ss3.length;i2++){
    if(mmsg.equals(ss3[i2]) && ! cmd.auth(proc,uin, "exthelp")){
    helpMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
    return;
      }
    }
if(mmsg.equals(ss[i1])){

s = cmd.psp.loadText("./text/" + cmd.srv.getName() + "/help/"+ss2[i1]).split("<br>");
for (int i = 0; i < s.length; i++) {
proc.mq.add(uin, s[i]);
}
helpMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
return;
}
if(mmsg.trim().equals("0")){
proc.mq.add(uin, "    !");
helpMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
        return;
}

    }
proc.mq.add(uin, "    . .    !");
helpMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
break;

}
}catch(Exception ex){
ex.printStackTrace();
proc.mq.add(uin,"Error: "+ex.getMessage());
}
}
}