package ru.jimbot.modules.chat;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.HashMap;
import java.util.Vector;
import ru.jimbot.modules.Cmd;
import ru.jimbot.modules.CommandExtend;
import ru.jimbot.modules.CommandParser;
import ru.jimbot.protocol.IcqProtocol;

    /**
     * @author 
     * ,       ,          
     */

    public class Shop {
    private HashMap<String, Cmd> commands = new HashMap<String, Cmd>();
    private HashMap<String, CommandExtend> MagMap;
    private CommandParser parser;
    private ChatCommandProc cmd;

    public Shop(ChatCommandProc c){
    parser = new CommandParser(commands);
    cmd = c;
    MagMap = new HashMap<String, CommandExtend>();
    init();
    }

    private void init(){
    commands.put("!", new Cmd("!","",1));
    commands.put("!", new Cmd("!","",2));
    commands.put("!", new Cmd("!","",3));
    commands.put("!", new Cmd("!","",4));
    commands.put("!", new Cmd("!","$c $n",5));
    commands.put("!", new Cmd("!","$c $n $s",6));
    
    }
	
    public boolean commandShop(IcqProtocol proc, String uin, String mmsg) {
    String tmsg = mmsg.trim();
    int tp = 0;
    if(MagMap.containsKey(uin))
    if(!MagMap.get(uin).isExpire())
    tp = parser.parseCommand(MagMap.get(uin).getCmd());
    else {
    tp = parser.parseCommand(tmsg);
    MagMap.remove(uin);
    }else
    tp = parser.parseCommand(tmsg);
    int tst=0;
    if(tp<0)
    tst=0;
    else
    tst = tp;
    boolean f = true;
    switch (tst){
    case 1:
    MagAvto(proc, uin, parser.parseArgs(tmsg), mmsg);
    break;
    case 2:
    MagDom(proc, uin, parser.parseArgs(tmsg), mmsg);
    break;
    case 3:
    MagOdej(proc, uin, parser.parseArgs(tmsg), mmsg);
    break;
    case 4:
    MagJivot(proc, uin, parser.parseArgs(tmsg), mmsg);
    break;
    case 5:
    Del(proc, uin, parser.parseArgs(tmsg));
    break;
    case 6:
    Add(proc, uin, parser.parseArgs(tmsg));
    break;
   
    default:
    f = false;
    }
    return f;
    }

private void MagAvto(IcqProtocol proc, String uin, Vector v, String mmsg) {
    if(!cmd.isChat(proc,uin) && !cmd.psp.testAdmin(uin)) return;
    Users uss = cmd.srv.us.getUser(uin);
    int i = 0;
    boolean AVTO = false;
    if(MagMap.containsKey(uin)){
        try{
            i = Integer.parseInt(mmsg);
        } catch(NumberFormatException e){
            proc.mq.add(uin,uss.localnick + "   .\n   '0'");
            return;
        }
        if(i != 0 && (getCount("auto",i)) == 0){
            proc.mq.add(uin,uss.localnick + "     ,  .\n   '0'");
            return;
        }
        if(uss.ball < (Price("auto",i))){
            proc.mq.add(uin,uss.localnick + "     " + ((Price("auto",i))-uss.ball) + "   ");
            return;
        }
        AVTO = true;
        MagMap.remove(uin);
    }
    if(!AVTO){
        proc.mq.add(uin,ListTovar("auto"));
        MagMap.put(uin, new CommandExtend(uin, mmsg, mmsg,v, 2*60000));
        return;
    }
    if(i == 0){proc.mq.add(uin,uss.localnick + "    "); return;}
    uss.ball -= Price("auto",i);
    uss.auto = Tovar("auto",i);
    cmd.srv.us.updateUser(uss);
    proc.mq.add(uin,uss.localnick + "    - '" + Tovar("auto",i) + "'\n   " + uss.ball +" "+cmd.psp.getStringProperty("valuta.chat"));
}

private void MagDom(IcqProtocol proc, String uin, Vector v, String mmsg) {
    if(!cmd.isChat(proc,uin) && !cmd.psp.testAdmin(uin)) return;
    Users uss = cmd.srv.us.getUser(uin);
    int i = 0;
    boolean DOM = false;
    if(MagMap.containsKey(uin)){
        try{
            i = Integer.parseInt(mmsg);
        } catch(NumberFormatException e){
            proc.mq.add(uin,uss.localnick + "   .\n   '0'");
            return;
        }
        if(i != 0 && (getCount("dom",i)) == 0){
            proc.mq.add(uin,uss.localnick + "     ,  .\n   '0'");
            return;
        }
        if(uss.ball < (Price("dom",i))){
            proc.mq.add(uin,uss.localnick + "     " + ((Price("dom",i))-uss.ball) + "   ");
            return;
        }
        DOM = true;
        MagMap.remove(uin);
    }
    if(!DOM){
        proc.mq.add(uin,ListTovar("dom"));
        MagMap.put(uin, new CommandExtend(uin, mmsg, mmsg,v, 2*60000));
        return;
    }
    if(i == 0){proc.mq.add(uin,uss.localnick + "    "); return;}
    uss.ball -= Price("dom",i);
    uss.dom = Tovar("dom",i);
    cmd.srv.us.updateUser(uss);
    proc.mq.add(uin,uss.localnick + "    - '" + Tovar("dom",i) + "'\n   " + uss.ball +" "+cmd.psp.getStringProperty("valuta.chat"));
}

private void MagOdej(IcqProtocol proc, String uin, Vector v, String mmsg) {
    if(!cmd.isChat(proc,uin) && !cmd.psp.testAdmin(uin)) return;
    Users uss = cmd.srv.us.getUser(uin);
    int i = 0;
    boolean ODEJ = false;
    if(MagMap.containsKey(uin)){
        try{
            i = Integer.parseInt(mmsg);
        } catch(NumberFormatException e){
            proc.mq.add(uin,uss.localnick + "   .\n   '0'");
            return;
        }
        if(i != 0 && (getCount("odegd",i)) == 0){
            proc.mq.add(uin,uss.localnick + "     ,  .\n   '0'");
            return;
        }
        if(uss.ball < (Price("odegd",i))){
            proc.mq.add(uin,uss.localnick + "     " + ((Price("odegd",i))-uss.ball) + "   ");
            return;
        }
        ODEJ = true;
        MagMap.remove(uin);
    }
    if(!ODEJ){
        proc.mq.add(uin,ListTovar("odegd"));
        MagMap.put(uin, new CommandExtend(uin, mmsg, mmsg,v, 2*60000));
        return;
    }
    if(i == 0){proc.mq.add(uin,uss.localnick + "    "); return;}
    uss.ball -= Price("odegd",i);
    uss.odegd = Tovar("odegd",i);
    cmd.srv.us.updateUser(uss);
    proc.mq.add(uin,uss.localnick + "    - '" + Tovar("odegd",i) + "'\n   " + uss.ball +" "+cmd.psp.getStringProperty("valuta.chat"));
}

private void MagJivot(IcqProtocol proc, String uin, Vector v, String mmsg) {
    if(!cmd.isChat(proc,uin) && !cmd.psp.testAdmin(uin)) return;
    Users uss = cmd.srv.us.getUser(uin);
    int i = 0;
    boolean JIV = false;
    if(MagMap.containsKey(uin)){
        try{
            i = Integer.parseInt(mmsg);
        } catch(NumberFormatException e){
            proc.mq.add(uin,uss.localnick + "   .\n   '0'");
            return;
        }
        if(i != 0 && (getCount("giv",i)) == 0){
            proc.mq.add(uin,uss.localnick + "     ,  .\n   '0'");
            return;
        }
        if(uss.ball < (Price("giv",i))){
            proc.mq.add(uin,uss.localnick + "     " + ((Price("giv",i))-uss.ball) + "   ");
            return;
        }
        JIV = true;
        MagMap.remove(uin);
    }
    if(!JIV){
        proc.mq.add(uin,ListTovar("giv"));
        MagMap.put(uin, new CommandExtend(uin, mmsg, mmsg,v, 2*60000));
        return;
    }
    if(i == 0){proc.mq.add(uin,uss.localnick + "    "); return;}
    uss.ball -= Price("giv",i);
    uss.giv = Tovar("giv",i);
    cmd.srv.us.updateUser(uss);
    proc.mq.add(uin,uss.localnick + "    - '" + Tovar("giv",i) + "'\n   " + uss.ball +" "+cmd.psp.getStringProperty("valuta.chat"));
}

    /*
     *  
     */
    public String ListTovar(String table) {
    String list = "    :\n" +
    " ~   \n";
    try{
    PreparedStatement pst = (PreparedStatement) cmd.srv.us.db.getDb().prepareStatement("select id, tovar, price from " + table);
    ResultSet rs = pst.executeQuery();
    while(rs.next()){
    list += rs.getInt(1) + " ~ " + rs.getString(2) +  "  " + rs.getInt(3) + '\n';
    }
    rs.close();
    pst.close();
    }catch (Exception ex){
    ex.printStackTrace();
    }
    list += "   \n   '0'";
    return list;
    }

    /*
     *  
     */
    private void Add(IcqProtocol proc, String uin, Vector v) {
    if(!cmd.isChat(proc,uin) && !cmd.psp.testAdmin(uin)) return;
    if(!cmd.auth(proc,uin, "gift")) return;
    try{
        Users uss = cmd.srv.us.getUser(uin);
        String table = (String)v.get(0);
        int price = (Integer)v.get(1);
        String tovar = (String)v.get(2);
        if(table.equals("") || table.equals(" ")){
        proc.mq.add(uin,uss.localnick + "       (, , , )");
        return;
        }
        String table2 = table.toLowerCase();// 
        table2 = table2.replace("", "auto");
        table2 = table2.replace("", "dom");
        table2 = table2.replace("", "odegd");
        table2 = table2.replace("", "giv");
        if(!TestTable(table2)){
        proc.mq.add(uin,uss.localnick + "    (, , , )");
        return;
        }
        if(price <= 0){
        proc.mq.add(uin,uss.localnick + "     '0'   '0'");
        return;
        }
        if(tovar.equals("") || tovar.equals(" ")){
        proc.mq.add(uin,uss.localnick + "       ");
        return;
        }
        if (cmd.radm.testMat1(cmd.radm.changeChar(tovar))){
        proc.mq.add(uin,uss.localnick + "     ''");
        return;
        }
        if(tovar.length() > 50){
        proc.mq.add(uin,uss.localnick + "    ");
        return;
        }
        AddBD(table2, tovar, price);
        proc.mq.add(uin,uss.localnick + "     ");
        }catch (Exception ex){
        ex.printStackTrace();
        proc.mq.add(uin,"     - "+ex.getMessage());
        }
        }

    /*
     *  
     */
    private void Del(IcqProtocol proc, String uin, Vector v) {
    if(!cmd.isChat(proc,uin) && !cmd.psp.testAdmin(uin)) return;
    if(!cmd.auth(proc,uin, "gift")) return;
    try{
        Users uss = cmd.srv.us.getUser(uin);
        String table = (String)v.get(0);
        int id = (Integer)v.get(1);
        String table2 = table.toLowerCase();// 
        table2 = table2.replace("", "auto");
        table2 = table2.replace("", "dom");
        table2 = table2.replace("", "odegd");
        table2 = table2.replace("", "giv");
        if(!TestTable(table2)){
        proc.mq.add(uin,uss.localnick + "    (, , , )");
        return;
        }
        if(getCount(table2,id) == 0){
        proc.mq.add(uin,uss.localnick + "   ");
        return;
        }
        proc.mq.add(uin,uss.localnick + "  '" + Tovar(table2,id) + "'  ");
        cmd.srv.us.db.executeQuery("DELETE FROM " + table2 + " WHERE id=" + id);
        cmd.srv.us.db.executeQuery("REPAIR TABLE " + table2);
        }catch (Exception ex){
        ex.printStackTrace();
        proc.mq.add(uin,"     - "+ex.getMessage());
        }
        }

   public boolean TestTable(String table) {
    try{
    PreparedStatement pst = (PreparedStatement) cmd.srv.us.db.getDb().prepareStatement("SELECT * FROM " + table + " WHERE 0");
    ResultSet rs = pst.executeQuery();
    rs.close();
    pst.close();
    }catch (Exception e){
    return false;
    }
    return true;
    }

    public int getCount(String table, int id){
    String q = "SELECT count(*) FROM " + table + " WHERE id="+id;
    Vector<String[]> v = cmd.srv.us.db.getValues(q);
    return Integer.parseInt(v.get(0)[0]);
    }

    public int Price(String table, int id) {
    int price = 0;
    try{
    PreparedStatement pst = (PreparedStatement) cmd.srv.us.db.getDb().prepareStatement("select price from " + table + " where id=" + id);
    ResultSet rs = pst.executeQuery();
    if(rs.next()){
        price += rs.getInt(1);
    }
    rs.close();
    pst.close();
    }catch (Exception ex){
    ex.printStackTrace();
    }
    return price;
    }

    public String Tovar(String table, int id) {
    String tovar = "";
    try{
    PreparedStatement pst = (PreparedStatement) cmd.srv.us.db.getDb().prepareStatement("select tovar from " + table + " where id=" + id);
    ResultSet rs = pst.executeQuery();
    if(rs.next()){
        tovar += rs.getString(1);
    }
    rs.close();
    pst.close();
    }catch (Exception ex){
    ex.printStackTrace();
    }
    return tovar;
    }

    public void AddBD(String table, String tovar, int price) {
    try {
    PreparedStatement pst = (PreparedStatement) cmd.srv.us.db.getDb().prepareStatement("insert into " + table + " values(null, ?, ?)");
    pst.setString(1,tovar);
    pst.setInt(2,price);
    pst.execute();
    pst.close();
    }catch (Exception ex){
    ex.printStackTrace();
    }
    }

}