/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ru.jimbot.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Properties;
import ru.jimbot.table.UserPreference;

/**
 * @author Warik777
 */
public class PlainProp {

public static HashMap<String,PlainProp> props = new HashMap<String,PlainProp>();
public String PROPS_FILE = "";
public String PROPS_FOLDER = "";
public String ENCODING = "windows-1251";
private Properties   appProps;

/** Creates a new instance of ShootingProp */
public PlainProp() {}

/**
 * @param name -  
 * @return
 */
public static PlainProp getInstance(String name){
if(props.containsKey(name)) {
return props.get(name);
} else {
PlainProp p = new PlainProp();
p.PROPS_FILE = "./services/"+name+"/plain.xml";
p.PROPS_FOLDER = "./services/"+name;
p.setDefault();
p.load();
props.put(name, p);
return p;
}
}

public void setDefault() {
appProps = new Properties();
setIntProperty("plain.weaponCount", 0/*1*/);
//setStringProperty("plain.name0", ""); //
//setIntProperty("plain.price0", 0); //
//setIntProperty("plain.criminality0", 0); // 
//setIntProperty("plain.health0", 0); // 
//setIntProperty("plain.purse0", 0); // 
//setIntProperty("plain.reward0", 0); //
}

/**
 * @param id -  
 * @return
 */
public UserPreference[] getPlainPreference(int id){
UserPreference[] p = {
new UserPreference(UserPreference.CATEGORY_TYPE, "plain"," ["+id+"]",""),
new UserPreference(UserPreference.STRING_TYPE,  "plain.name"+id," ",getStringProperty("plain.name"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "plain.price"+id," ",getIntProperty("plain.price"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "plain.criminality"+id,"  ",getIntProperty("plain.criminality"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "plain.health"+id,"  ",getIntProperty("plain.health"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "plain.purse"+id,"  ",getIntProperty("plain.purse"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "plain.reward"+id," ",getIntProperty("plain.reward"+id)),
};
return p;
}

/**
 *  
 * @return
 */
public int weaponCount(){
return getIntProperty("plain.weaponCount");
}

/**
 *  
 * @param i -  
 * @return
 */
public String getName(int i){
return getStringProperty("plain.name"+i);
}

/**
 *  
 * @param i -  
 * @return
 */
public int getPrice(int i){
return getIntProperty("plain.price"+i);
}

/**
 *  
 * @param i -  
 * @return
 */
public int getCriminality(int i){
return getIntProperty("plain.criminality"+i);
}

/**
 *  
 * @param i -  
 * @return
 */
public int getHealth(int i){
return getIntProperty("plain.health"+i);
}

/**
 *  
 * @param i -  
 * @return
 */
public int getPurse(int i){
return getIntProperty("plain.purse"+i);
}

/**
 * 
 * @param i -  
 * @return
 */
public int getReward(int i){
return getIntProperty("plain.reward"+i);
}

/**
 *  
 * @param i
 * @param name - 
 * @param price - 
 * @param criminality -  
 * @param health -  
 * @param purse -  
 * @param reward - 
 */
public void setWeapon(int i, String name, int price, int criminality, int health, int purse, int reward){
setStringProperty("plain.name"+i, name);
setIntProperty("plain.price"+i, price);
setIntProperty("plain.criminality" + i, criminality);
setIntProperty("plain.health"+i, health);
setIntProperty("plain.purse"+i, purse);
setIntProperty("plain.reward"+i, reward);
}

/**
 *   
 * @param name - 
 * @param price - 
 * @param criminality -  
 * @param health -  
 * @param purse -  
 * @param reward - 
 * @return -   
 */
public int addWeapon(String name, int price, int criminality, int health, int purse, int reward){
int c = weaponCount();
setIntProperty("plain.weaponCount",c + 1);
setStringProperty("plain.name"+c, name);
setIntProperty("plain.price" + c, price);
setIntProperty("plain.criminality" + c, criminality);
setIntProperty("plain.health" + c, health);
setIntProperty("plain.purse" + c, purse);
setIntProperty("plain.reward" + c, reward);
return c;
}



/**
 *  
 * @param c
 */
public void delWeapon(int c) {
//   
for(int i=0; i<(weaponCount()-1); i++){
if(i>=c){
setStringProperty("plain.name" + i, getName(i+1));
setIntProperty("plain.price" + i, getPrice(i+1));
setIntProperty("plain.criminality" + i, getCriminality(i+1));
setIntProperty("plain.health" + i, getHealth(i+1));
setIntProperty("plain.purse" + i, getPurse(i+1));
setIntProperty("plain.reward" + i, getReward(i+1));
}
}
//   
appProps.remove("plain.name"+(weaponCount()-1));
appProps.remove("plain.price"+(weaponCount()-1));
appProps.remove("plain.criminality"+(weaponCount()-1));
appProps.remove("plain.health"+(weaponCount()-1));
appProps.remove("plain.purse"+(weaponCount()-1));
appProps.remove("plain.reward"+(weaponCount()-1));
setIntProperty("plain.weaponCount", (weaponCount()-1));
}

public void delallWeapon() {

for(int i=1; i<(weaponCount()-1); i++){


appProps.remove("plain.name"+i);
appProps.remove("plain.price"+i);
appProps.remove("plain.criminality"+i);
appProps.remove("plain.health"+i);
appProps.remove("plain.purse"+i);
appProps.remove("plain.reward"+i);
setIntProperty("plain.weaponCount", 1);
}
}
//*****************************************

    @SuppressWarnings("CallToThreadDumpStack")
public void load(  ) {
File file = new File(PROPS_FILE);
if(!file.exists()){
String[] xml = PROPS_FILE.split("/");
Log.error(xml[2] + ".xml  !");
return;
}
setDefault();
try {
FileInputStream fi = new FileInputStream(file);
appProps.loadFromXML(fi);
fi.close();
Log.info("Load DataBase XML Plain Weapon");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error opening DataBase XML Plain Weapon: ");
}
}

    @SuppressWarnings("CallToThreadDumpStack")
public void save() {
File file = new File(PROPS_FILE);
File dir = new File(this.PROPS_FOLDER);
try {
if(!dir.exists()) {dir.mkdirs();}
FileOutputStream fo = new FileOutputStream(file);
appProps.storeToXML(fo, "DataBase XML for jImBot properties");
fo.close();
Log.info("Save DataBase XML Plain Weapon");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error saving DataBase XML Plain Weapon: ");
}
}

    @SuppressWarnings("CallToThreadDumpStack")
public void AddXmlConfig (String name){
String Xml = "./services/" + name + "/plain.xml";
File NEW = new File(Xml);
try {
FileOutputStream fo = new FileOutputStream(NEW);
appProps.storeToXML(fo, "DataBase XML for jImBot properties");
fo.close();
Log.info(name + ".xml   !");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error saving DataBase XML Plain Weapon: ");
}
}

public Properties getProps(){
return appProps;
}

public void registerProperties(Properties _appProps) {
appProps = _appProps;
}

public String getProperty(String key) {
return appProps.getProperty(key);
}

public String getStringProperty(String key) {
return appProps.getProperty(key);
}

public String getProperty(String key, String def) {
return appProps.getProperty(key,def);
}

public void setProperty(String key, String val) {
appProps.setProperty(key,val);
}

public void setStringProperty(String key, String val) {
appProps.setProperty(key,val);
}

public void setIntProperty(String key, int val) {
appProps.setProperty(key,Integer.toString(val));
}

public void setBooleanProperty(String key, boolean val) {
appProps.setProperty(key, val ? "true":"false");
}

public int getIntProperty(String key) {
return Integer.parseInt(appProps.getProperty(key));
}

public boolean getBooleanProperty(String key) {
return Boolean.valueOf(appProps.getProperty(key)).booleanValue();
}


}