/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ru.jimbot.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Properties;
import java.util.Random;
import ru.jimbot.table.UserPreference;

/**
 * @author Warik777
 */
public class ShootingProp {

public static HashMap<String,ShootingProp> props = new HashMap<String,ShootingProp>();
public String PROPS_FILE = "";
public String PROPS_FOLDER = "";
public String ENCODING = "windows-1251";
private Properties   appProps;

/** Creates a new instance of ShootingProp */
public ShootingProp() {}

/**
 * @param name -  
 * @return
 */
public static ShootingProp getInstance(String name){
if(props.containsKey(name)) {
return props.get(name);
} else {
ShootingProp p = new ShootingProp();
p.PROPS_FILE = "./services/"+name+"/amount.xml";
p.PROPS_FOLDER = "./services/"+name;
p.setDefault();
p.load();
props.put(name, p);
return p;
}
}

public void setDefault() {
appProps = new Properties();
setIntProperty("amount.weaponCount", 0/*1*/);
//setStringProperty("amount.name0", ""); //
//setIntProperty("amount.price0", 0); //
//setIntProperty("amount.criminality0", 0); // 
//setIntProperty("amount.health0", 0); // 
//setIntProperty("amount.armour0", 0); // 
//setIntProperty("amount.purse0", 0); // 
//setIntProperty("amount.reward0", 0); //
}

/**
 * @param id -  
 * @return
 */
public UserPreference[] getAmountPreference(int id){
UserPreference[] p = {
new UserPreference(UserPreference.CATEGORY_TYPE, "amount"," ["+id+"]",""),
new UserPreference(UserPreference.STRING_TYPE,  "amount.name"+id," ",getStringProperty("amount.name"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "amount.price"+id," ",getIntProperty("amount.price"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "amount.criminality"+id,"  ",getIntProperty("amount.criminality"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "amount.health"+id,"  ",getIntProperty("amount.health"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "amount.armour"+id,"  ",getIntProperty("amount.armour"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "amount.purse"+id,"  ",getIntProperty("amount.purse"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "amount.reward"+id," ",getIntProperty("amount.reward"+id)),
};
return p;
}

/**
 *  
 * @return
 */
public int weaponCount(){
return getIntProperty("amount.weaponCount");
}

/**
 *  
 * @param i -  
 * @return
 */
public String getName(int i){
return getStringProperty("amount.name"+i);
}

/**
 *  
 * @param i -  
 * @return
 */
public int getPrice(int i){
return getIntProperty("amount.price"+i);
}

/**
 *  
 * @param i -  
 * @return
 */
public int getCriminality(int i){
return getIntProperty("amount.criminality"+i);
}

/**
 *  
 * @param i -  
 * @return
 */
public int getHealth(int i){
return getIntProperty("amount.health"+i);
}

/**
 *  
 * @param i -  
 * @return
 */
public int getArmour(int i){
return getIntProperty("amount.armour"+i);
}

/**
 *  
 * @param i -  
 * @return
 */
public int getPurse(int i){
return getIntProperty("amount.purse"+i);
}

/**
 * 
 * @param i -  
 * @return
 */
public int getReward(int i){
return getIntProperty("amount.reward"+i);
}

/**
 *  
 * @param i
 * @param name - 
 * @param price - 
 * @param criminality -  
 * @param health -  
 * @param armour -  
 * @param purse -  
 * @param reward - 
 */
public void setWeapon(int i, String name, int price, int criminality, int health, int armour, int purse, int reward){
setStringProperty("amount.name"+i, name);
setIntProperty("amount.price"+i, price);
setIntProperty("amount.criminality" + i, criminality);
setIntProperty("amount.health"+i, health);
setIntProperty("amount.armour"+i, armour);
setIntProperty("amount.purse"+i, purse);
setIntProperty("amount.reward"+i, reward);
}

/**
 *   
 * @param name - 
 * @param price - 
 * @param criminality -  
 * @param health -  
 * @param armour -  
 * @param purse -  
 * @param reward - 
 * @return -   
 */
public int addWeapon(String name, int price, int criminality, int health, int armour, int purse, int reward){
int c = weaponCount();
setIntProperty("amount.weaponCount",c + 1);
setStringProperty("amount.name"+c, name);
setIntProperty("amount.price" + c, price);
setIntProperty("amount.criminality" + c, criminality);
setIntProperty("amount.health" + c, health);
setIntProperty("amount.armour" + c, armour);
setIntProperty("amount.purse" + c, purse);
setIntProperty("amount.reward" + c, reward);
return c;
}

/**
 *  
 * @param c
 */
public void delWeapon(int c) {
//   
for(int i=1; i<(weaponCount()-1); i++){
if(i>=c){
setStringProperty("amount.name" + i, getName(i+1));
setIntProperty("amount.price" + i, getPrice(i+1));
setIntProperty("amount.criminality" + i, getCriminality(i+1));
setIntProperty("amount.health" + i, getHealth(i+1));
setIntProperty("amount.armour" + i, getArmour(i+1));
setIntProperty("amount.purse" + i, getPurse(i+1));
setIntProperty("amount.reward" + i, getReward(i+1));
}
}
//   
appProps.remove("amount.name"+(weaponCount()-1));
appProps.remove("amount.price"+(weaponCount()-1));
appProps.remove("amount.criminality"+(weaponCount()-1));
appProps.remove("amount.health"+(weaponCount()-1));
appProps.remove("amount.armour"+(weaponCount()-1));
appProps.remove("amount.purse"+(weaponCount()-1));
appProps.remove("amount.reward"+(weaponCount()-1));
setIntProperty("amount.weaponCount", weaponCount()-1);
}


public void delallWeapon() {

for(int i=1; i<(weaponCount()-1); i++){


appProps.remove("amount.name"+i);
appProps.remove("amount.price"+i);
appProps.remove("amount.criminality"+i);
appProps.remove("amount.health"+i);
appProps.remove("amount.armour"+i);
appProps.remove("amount.purse"+i);
appProps.remove("amount.reward"+i);
setIntProperty("amount.weaponCount", 1);
}
}
//*****************************************

    @SuppressWarnings("CallToThreadDumpStack")
public void load(  ) {
File file = new File(PROPS_FILE);
if(!file.exists()){
String[] xml = PROPS_FILE.split("/");
Log.error(xml[2] + ".xml  !");
return;
}
setDefault();
try {
FileInputStream fi = new FileInputStream(file);
appProps.loadFromXML(fi);
fi.close();
Log.info("Load DataBase XML Weapon");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error opening DataBase XML Weapon: ");
}
}

    @SuppressWarnings("CallToThreadDumpStack")
public void save() {
File file = new File(PROPS_FILE);
File dir = new File(this.PROPS_FOLDER);
try {
if(!dir.exists()) {dir.mkdirs();}
FileOutputStream fo = new FileOutputStream(file);
appProps.storeToXML(fo, "DataBase XML for jImBot properties");
fo.close();
Log.info("Save DataBase XML Weapon");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error saving DataBase XML Weapon: ");
}
}

    @SuppressWarnings("CallToThreadDumpStack")
public void AddXmlConfig (String name){
String Xml = "./services/" + name + "/amount.xml";
File NEW = new File(Xml);
try {
FileOutputStream fo = new FileOutputStream(NEW);
appProps.storeToXML(fo, "DataBase XML for jImBot properties");
fo.close();
Log.info(name + ".xml   !");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error saving DataBase XML Weapon: ");
}
}

/**
 *  
 * @param id (0-|1-)
 * @return
 */
public String getRName(int id){
String v = "";
if(id == 0){
String[] s = {"-81 ","Franchi SPAS-12","Benelli M1 super 90 series","Mossberg model 500","Remington 870",
"TT","Walther P38","-38","","","-98","-","","-47","","-74","-74","-102","-104","-105",
" -01"," -23"," -33","-40","","","","","","","-444- ","","Desert Eagle",
"-14 ","","INSAS","Tavor TAR-21","CZ SA Vz.58","Zastava_M21S","Valmet M82",
"Valmet Rk.62","Valmet Rk. 76TP","Valmet Rk.95","Micro TAVOR","-3 ","MG-30","Bren L4","FN Minimi M249",
"Bren L4L86A1 - SA-80","MG3","Heckler & Koch HK MG-43","Browning M2","MG34","","Madsen",
"","","","","","",
"SS-77"," 100","Lewis 1915","N T mle F1","","-46","M134 Minigun","Vickers .303 Mk.I.",
"Fiat-Revelli mod.14.","Johnson M1941","Johnson M1944",
"Beretta M12","-19-01 ","Scorpion CZ 361","American-180","-919","S1-100",
"Tavor MTAR 21 / Micro Tavor","Magal","Vigneron M2","FN P90","AuSTEN","FMK-3","Shipka",
" -91"," -9","-2000","Kiraly 39M","Kiraly 43M","Thompson M1921","Reising M50","UD M42",
"Ares FMG","Schmeisser MP.28,II","Bergmann MP-35","Erma EMP 35","MP.38","MP.40","Schmeisser MP.41",
"Walther MPL","Walther MPK","Heckler und Koch MP-5","Heckler und Koch MP-5k","Heckler und Koch UMP",
"Heckler - Koch HK MP7A1 PDW","Star Z-62","Star Z-70B","Star Z-84","Franchi LF-57","Spectre M4","Chang Feng","PM-63",
"PM-84 Glauberyt","Suomi M-1931","ST Kinetics CPW","MAS Mle 1938","MAT-49","Hotchkiss","MGD / ERMA PM-9",
"SIG MKPS MKMS MKPO MKMO","W+F Lmg.-Pist 41 Furrer","W+F Lmg.-Pist 44 Furrer","Brugger+Thomet MP 9","Carl Gustaf Kpist M/45","CBJ-MS PDW",
"ZK-383","Sa. 23","Sa. 24","Sa. 25","Sa. 26","FAMAE S.A.F.","BXP","Daewoo K7","M49","M56","MGV-176","Minebea M-9","-41",
"-43"," -19","-90","-93","-901"," -02","-2 ","TDI Kriss Super V ","Sterling L2A3",
"Metal Storm","HK69","HK79","AG36","AG-C","EGLM","XM320","HK GMG","Panzerfaust 44 Lanze","Panzerfaust 3","Armbrust",
"-2","-7","-16","-18 ","-22 ","-26 ","-27 ","-28","-29",
"-32","-1","-2",""," -","-","-25","-30","Safir T15","TPD AXR rifle","SIG 556","Ruger SR-556",
"Ruger Mini-14","Ruger PC-4","Remington 7615","Remington 7600","Ruger PC-9","MSAR STG-556 rifle","Magpul MASADA / ACR",
"KRISS Vector CRB/SO","Kel-tec SU 16","Kel-tec SUB 2000","Hi-Point Model 995","Armalite AR-7","Sayga","Benelli MR1",
"Beretta RX4","Beretta CX4","Heckler-Koch HK USC","Heckler-Koch HK SL-8","Heckler-Koch HK SL-6 SL-7","Armalon PC","Arms M10",
"Steyr.50 HS","M500","M600","AMAC-5100","M650","","SSG 69","Accuracy International AS50","RPA","DSR 50","M99"," 12.7",
"-96","","Barrett Light Fifty M82A1","Barrett Light Fifty M82A2","Barrett Light Fifty M82A3","Barrett M90",
"Barrett M95","M99","M99-1","XM500","McMillan TAC-50","RT-20","OM 50 Nemesis","Truvelo .50",
"Kimar 85 auto","-200","STALKER","SAFEGOM","","","Reck Cobra","",""};
Random r = new Random();
v = s[r.nextInt((s.length))];
} else if (id == 1){
String s [] = {"","","  ","","","",""," ","","",
"","",""," ","","","","","","","","","","",
"","",""," ","","",""," "," "," ",
"","","","",""," ","","","","","","","",
" ","","","","","","","","","","","",
"","","","","","","","","","","","","",
" ","","","","","","","","","","-","","",
"","","","","","",""," ","","","","",
"","","",""," ","","","","","","",
" ","","","",""};
Random r = new Random();
v = s[r.nextInt((s.length))];
}
return v;
}

/**
 *   
 * @param col
 * @return
 */
public String getRPrice(int col){
String v = "";
Random r = new Random();
if(1 < col){
String c = "1234567890";
for(int i=0;i<col;i++){
v += c.charAt(r.nextInt(c.length()));
}
}else if(col == 1){
String c = "123456789";
for(int i=0;i<col;i++){
v += c.charAt(r.nextInt(c.length()));
}
}
return v;
}

public Properties getProps(){
return appProps;
}

public void registerProperties(Properties _appProps) {
appProps = _appProps;
}

public String getProperty(String key) {
return appProps.getProperty(key);
}

public String getStringProperty(String key) {
return appProps.getProperty(key);
}

public String getProperty(String key, String def) {
return appProps.getProperty(key,def);
}

public void setProperty(String key, String val) {
appProps.setProperty(key,val);
}

public void setStringProperty(String key, String val) {
appProps.setProperty(key,val);
}

public void setIntProperty(String key, int val) {
appProps.setProperty(key,Integer.toString(val));
}

public void setBooleanProperty(String key, boolean val) {
appProps.setProperty(key, val ? "true":"false");
}

public int getIntProperty(String key) {
return Integer.parseInt(appProps.getProperty(key));
}

public boolean getBooleanProperty(String key) {
return Boolean.valueOf(appProps.getProperty(key)).booleanValue();
}

}