package ru.jimbot.modules;

import ru.jimbot.protocol.IcqProtocol;
import ru.jimbot.util.Log;

public class StartUins implements Runnable {
    private Thread th;
    private UINmanager um;

    public StartUins(UINmanager um) {
        this.um = um;
    }


    public void start(){
        th = new Thread(this);
        th.setPriority(Thread.NORM_PRIORITY);
        th.start();
    }

    public synchronized void stop() {
        th = null;
        notify();
    }

    public void run() {
        for(int i=0;i<um.count();i++){
            ((IcqProtocol)um.proc.get(i)).connect();
             try {
                 Log.info(i+"_ "+(um.timeOut/1000)+".    uin");

                th.sleep(um.timeOut);
            } catch (InterruptedException e) { break; }
           }
        stop();
    }
 }