/**
 * JimBot - Java IM Bot
 * Copyright (C) 2010 JimBot project
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package ru.jimbot.modules.chat;

import java.sql.PreparedStatement;
import java.util.HashMap;
import java.util.Vector;
import java.io.File;
import ru.jimbot.modules.Cmd;
import ru.jimbot.modules.CommandParser;
import ru.jimbot.protocol.IcqProtocol;
import ru.jimbot.util.Log;

/**
 * @author Fraer72
 * @rewrite Warik777
 *    :)
 */
public class AboutUser {
private HashMap<String, Cmd> commands = new HashMap<String, Cmd>();
private CommandParser parser;
private ChatCommandProc cmd;

public AboutUser(ChatCommandProc c){
parser = new CommandParser(commands);
cmd = c;
init();
}

private void init(){
commands.put("!", new Cmd("!","$n",1));
commands.put("!", new Cmd("!","$n",2));
}

/**
 *   
 * @param name
 * @param c
 * @return - ,    
 */
public boolean addCommand(String name, Cmd c){
boolean f = commands.containsKey(name);
commands.put(name, c);
return f;
}

public boolean commandAboutUser(IcqProtocol proc, String uin, String mmsg) {
String tmsg = mmsg.trim();
int tp = parser.parseCommand(tmsg);
int tst=0;
if(tp<0)
tst = 0;
else
tst = tp;
boolean f = true;
switch (tst) {
case 1:
commandSP(proc, uin, parser.parseArgs(tmsg));
break;
case 2:
commandPol(proc, uin, parser.parseArgs(tmsg));
break;

default:
f = false;
}
return f;
}

public void commandPol(IcqProtocol proc, String uin, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
try {
int i = ((Integer)v.get(0)).intValue();
Users uss = cmd.srv.us.getUser(uin);
if (i<1 || i>2) {
proc.mq.add(uin, "   1  2,\n! 1 -;\n! 2 -;");
return;
}
uss.pol = i;
///
//if (uss.pol==1) {
//uss.homepage="";
//}else if (uss.pol==2){
//    uss.homepage="";
//}
///
Log.talk(" !");
proc.mq.add(uin, "    !");
}catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}

/**
*   :)
* @rewrite   (Warik777)
* @param proc
* @param uin
* @param v
*/
public void commandSP(IcqProtocol proc, String uin, Vector v){
if(!cmd.isChat(proc,uin) && !cmd.psp.testAdmin(uin)) return;
//int id = (Integer)v.get(1);
int id2 = (Integer)v.get(0);
String lstatus = "";
String m = "";
Users uss = cmd.srv.us.getUser(uin);
//Users u = cmd.srv.us.getUser(id);
try{
if(uss.pol==0) {
proc.mq.add(uin, "   ,      !");
return;
}

if(id2 == 7){
if(uss.pol ==2) cmd.srv.cq.addMsg(uss.localnick + "[" + uss.id + "]" + "   ", uss.sn, uss.room);
if(uss.pol == 1) cmd.srv.cq.addMsg(uss.localnick + "[" + uss.id + "]" + "   ", uss.sn, uss.room);

uss.sv_status = "";
cmd.srv.us.updateUser(uss);

proc.mq.add(uin, "  ");
return;
}
if (id2 == 0 || id2>6){
String s = "    \n";
s +="1. / \n";
s +="2. /\n";
s +="3./\n";
s +="4. \n";
s +="5./\n";
s +="6.  \n";
s +="7. \n";
s +="  ! <  >\n";
proc.mq.add(uin, s);
return;
}
if(id2 == 1){
if(uss.pol ==2)lstatus=" ";
if(uss.pol ==1)lstatus=" ";
//id = 0;
}
if(id2 == 2){
if(uss.pol ==2)lstatus=" ";
if(uss.pol ==1)lstatus=" ";
//if(id !=0){
//if(uss.pol ==2)lstatus=""; m=" c";
//if(uss.pol ==1)lstatus=""; m=" c";
//}
}
if(id2 == 3){
if(uss.pol ==2)lstatus="";
if(uss.pol ==1)lstatus="";
//if(id !=0){
//if(uss.pol ==2)lstatus=""; m=" ";
//if(uss.pol ==1)lstatus=""; m="  ";
//}
}
if(id2 == 4){
lstatus=" ";
//if(id !=0){
//lstatus=" ";
//}
}
if(id2 == 5){
if(uss.pol ==2)lstatus="";
if(uss.pol ==1)lstatus="";
//if(id !=0){
//if(uss.pol ==2)lstatus=""; m=" ";
//if(uss.pol ==1)lstatus=""; m=" ";
//}
}
if(id2 == 6){
lstatus="  ";
}
proc.mq.add(uin, " : " +lstatus);//+m+" "+cmd.srv.us.getUser(u.wedding).localnick);
uss.sv_status = lstatus;//+" "+cmd.srv.us.getUser(u.wedding).localnick;
cmd.srv.us.updateUser(uss);
return;
} catch (Exception ex) {
ex.printStackTrace();
}
}

}