/**
 * JimBot - Java IM Bot
 * Copyright (C) 2010 JimBot project
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package ru.jimbot.modules.chat;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import ru.jimbot.util.Log;

import java.util.Vector;
import java.util.HashMap;
import java.util.concurrent.ConcurrentHashMap;
import ru.jimbot.Messages;
import ru.jimbot.modules.Cmd;
import ru.jimbot.protocol.IcqProtocol;
import ru.jimbot.modules.CommandParser;

/** 
 * @rewrite  
 * @rewrite 
 */
public class BlacklDjeckl21 {
private HashMap<String, Cmd> commands = new HashMap<String, Cmd>();
private CommandParser parser;
private ChatCommandProc cmd;
private ConcurrentHashMap<String, String> ub;

/**Creates a new instance of Pricols*/
public BlacklDjeckl21(ChatCommandProc c) {
parser = new CommandParser(commands);
cmd = c;
ub = new ConcurrentHashMap();
init();
}

private void init() {
commands.put("!", new Cmd("!", "$n", 1));
commands.put("!", new Cmd("!", "$n", 2));
commands.put("!", new Cmd("!", "$c", 3));
commands.put("!", new Cmd("!", "$n", 4));
commands.put("!", new Cmd("!", "$c", 5));
commands.put("!21", new Cmd("!21", "", 6));
commands.put("!", new Cmd("!", "", 6));
}

public boolean commandBlacklDjeckl21(IcqProtocol proc, String uin, String mmsg) {
String tmsg = mmsg.trim();
int tp = parser.parseCommand(tmsg);
int tst=0;
if(tp<0) {
tst = 0;
} else {
tst = tp;
}
boolean f = true;
switch (tst) {
case 1:
commandKarta(proc, uin, parser.parseArgs(tmsg));
break;
case 2:
commandGame(proc, uin, parser.parseArgs(tmsg), mmsg);
break;
case 3:
commandIgraem(proc, uin, parser.parseArgs(tmsg), mmsg);
break;
case 4:
commandVskrut(proc, uin, parser.parseArgs(tmsg), mmsg);
break;
case 5:
commandPokazat(proc, uin, parser.parseArgs(tmsg), mmsg);
break;
case 6:
command21(proc,uin);
break;

default:
f = false;
break;
}
return f;
}

public void command21 (IcqProtocol proc, String uin) {
try {
String A = "";
A += " \n";
A += "! <> -   \n";
A += "!  -    \n";
A += "!  -   \n";
A += "!  -    \n";
proc.mq.add(uin, A);
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " +
ex.getMessage());
}
}

//
public void commandGame(IcqProtocol proc, String uin, Vector v, String tmsg){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
if (!(cmd.auth(proc, uin, "black_jack"))) {return;}
try {
int no = ((Integer)v.get(0)).intValue();
Users us = cmd.srv.us.getUser(uin);
Users uss = cmd.srv.us.getUser(no);
if ((uss.room != cmd.psp.getIntProperty("roomkazino")) && (us.room != cmd.psp.getIntProperty("roomkazino")) && (uss.room != cmd.psp.getIntProperty("roomkazino"))) {
proc.mq.add(uin, "  -    " + cmd.psp.getIntProperty("roomkazino") + cmd.srv.us.getRoom(cmd.psp.getIntProperty("roomkazino")).getName() + " ,      ..");
return;
}
if (us == uss) {
proc.mq.add(uin, "  ()  ");
return;
}
if (us.game != 0) {
proc.mq.add(uin, "     ,       ");
return;
}
if (uss == null) {
proc.mq.add(uin, "   ");
return;
}
if (!(cmd.srv.cq.testUser(uss.sn))) {
proc.mq.add(uin, "   ");
return;
}
if (us.ball < cmd.psp.getIntProperty("bllimit")) {
proc.mq.add(uin, "   - $  ..  ,     " + cmd.psp.getIntProperty("bllimit") + "..");
return;
}
if (uss.ball < cmd.psp.getIntProperty("bllimit")) {
proc.mq.add(uin, "      , .      - $ (    " + cmd.psp.getIntProperty("bllimit") + ")");
return;
}
if (uss.game != 0) {
proc.mq.add(uin, "     -, ,    ");
return;
}
Log.talk("CHAT: " + uss.sn + ">>      -  " + cmd.srv.us.getUser(uin).localnick + ": ");
cmd.srv.us.db.log(uss.id, uin, "OUT", ">>      -  " + cmd.srv.us.getUser(uin).localnick + ": ", uss.room);
cmd.srv.getIcqProcess(uss.basesn).mq.add(uss.sn, "     -  " + cmd.srv.us.getUser(uin).localnick + ";     ! ...  ! .. ");
setgame(uss.sn, uin);
proc.mq.add(uin, "  ");
cmd.srv.us.updateUser(uss);
cmd.srv.us.updateUser(us);
} catch (Exception ex) {
ex.printStackTrace();
Log.talk(uin + " Private msg error: " + tmsg);
proc.mq.add(uin, Messages.getString("ChatCommandProc.commandP.6"));
}
}

public void commandIgraem(IcqProtocol proc, String uin, Vector v, String tmsg){
if((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
if(!(cmd.auth(proc, uin, "black_jack"))) {return;}
try{
String txt = (String)v.get(0);
String fsn1 = testgame(uin);
Users us = cmd.srv.us.getUser(uin);
int p = 0;
String ss = "";
String s = "";
if (fsn1.equals("")) {
proc.mq.add(uin, "   ,  ");
return;
}
Users uss = cmd.srv.us.getUser(fsn1);
if(uss == null) {
proc.mq.add(uin, "   ");
return;
}
if((uss.room != cmd.psp.getIntProperty("roomkazino")) && (us.room != cmd.psp.getIntProperty("roomkazino")) && (uss.room != cmd.psp.getIntProperty("roomkazino"))) {
proc.mq.add(uin, "  -    " + cmd.psp.getIntProperty("roomkazino") + " ,      ..");
return;
}
if(!(cmd.srv.cq.testUser(uss.sn))) {
proc.mq.add(uin, "   ");
return;
}
if((txt.equals("")) || (txt.equals(" ")) || ((!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))))) {
proc.mq.add(uin, "   ");
return;
}
if((txt.equals("")) || (txt.equals("")) || (txt.equals("")) || (txt.equals(""))){
p = 2;
}else {
p = 0;
Log.talk("CHAT: " + uss.sn + ">>      " + cmd.srv.us.getUser(uin).localnick + ": " + txt);
cmd.srv.us.db.log(uss.id, uin, "OUT", ">>      " + cmd.srv.us.getUser(uin).localnick + ": " + txt, uss.room);
cmd.srv.getIcqProcess(uss.basesn).mq.add(uss.sn, "     " + cmd.srv.us.getUser(uin).localnick + ": " + txt);
setgame(uss.sn, uin);
proc.mq.add(uin, "  ");
}
if (p == 2){
PreparedStatement pst = (PreparedStatement)cmd.srv.us.db.getDb().prepareStatement("SELECT id, card, id_card FROM game ORDER BY RAND( ) LIMIT 0 ,1");
ResultSet rs = pst.executeQuery();
if (rs.next()) {
s = s + "   : " + rs.getString(2) + " , : " + rs.getInt(3) + " ()";
int reiting = uss.game + rs.getInt(3);
uss.game = reiting;
cmd.srv.us.updateUser(uss);
}
pst = (PreparedStatement)cmd.srv.us.db.getDb().prepareStatement("SELECT id, card, id_card FROM game ORDER BY RAND( ) LIMIT 0 , 1");
ResultSet bs = pst.executeQuery();
if (bs.next()) {
s = s + "  " + bs.getString(2) + " , : " + bs.getInt(3) + " ()";
int reiting = uss.game + bs.getInt(3);
uss.game = reiting;
cmd.srv.us.updateUser(uss);
s = s + ",    " + uss.game + " ()";
proc.mq.add(uss.sn, s);
}
pst = (PreparedStatement)cmd.srv.us.db.getDb().prepareStatement("SELECT id, card, id_card FROM game ORDER BY RAND( ) LIMIT 0 , 1");
ResultSet ms = pst.executeQuery();
if (ms.next()) {
ss = ss + "   : " + ms.getString(2) + " , : " + ms.getInt(3) + " ()";
int reiting = us.game + ms.getInt(3);
us.game = reiting;
cmd.srv.us.updateUser(us);
}
pst = (PreparedStatement)cmd.srv.us.db.getDb().prepareStatement("SELECT id, card, id_card FROM game ORDER BY RAND( ) LIMIT 0 , 1");
ResultSet cs = pst.executeQuery();
if (cs.next()) {
ss = ss + "  " + cs.getString(2) + " , : " + cs.getInt(3) + " ()";
int reiting = us.game + cs.getInt(3);
us.game = reiting;
cmd.srv.us.updateUser(us);
ss = ss + ",    " + us.game + " ()";
proc.mq.add(us.sn, ss);
}
rs.close();
pst.execute();
pst.close();
int reiting4 = uss.ball - cmd.psp.getIntProperty("bllimit");
uss.ball = reiting4;
cmd.srv.us.updateUser(uss);
int reiting2 = uss.score + cmd.psp.getIntProperty("bllimit");
uss.score = reiting2;
cmd.srv.us.updateUser(uss);
int reiting1 = us.ball - cmd.psp.getIntProperty("bllimit");
us.ball = reiting1;
cmd.srv.us.updateUser(us);
int reiting6 = us.score + cmd.psp.getIntProperty("bllimit");
us.score = reiting6;
cmd.srv.us.updateUser(us);
}
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, "  ");
}
}

public void commandKarta(IcqProtocol proc, String uin, Vector v){
if((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
if(!(cmd.auth(proc, uin, "black_jack"))) {return;}
try {
Users uss = cmd.srv.us.getUser(uin);
int r = ((Integer)v.get(0)).intValue();
String ss = "";
if ((uss.room != cmd.psp.getIntProperty("roomkazino")) && (uss.room != cmd.psp.getIntProperty("roomkazino")) && (uss.room != cmd.psp.getIntProperty("roomkazino"))) {
proc.mq.add(uin, "      " + cmd.psp.getIntProperty("roomkazino") + " ,      ..");
return;
}
if ((r == 0) || (r <= 1) || (r <= 0)) {
proc.mq.add(uin, "    ,      "+cmd.psp.getIntProperty("bllimit")+" $..");
return;
}
if (uss.ball < cmd.psp.getIntProperty("bllimit")) {
proc.mq.add(uin, "   - $  ..!");
return;
}

if (uss.game == 0) {
proc.mq.add(uin, "       ..    ");
return;
}
if (r> cmd.psp.getIntProperty("bleckmax")) {
proc.mq.add(uin, "   "+cmd.psp.getIntProperty("bleckmax"));
return;
}
int reiting1 = uss.ball - r;
uss.ball = reiting1;
cmd.srv.us.updateUser(uss);
int reiting2 = uss.score + r;
uss.score = reiting2;
cmd.srv.us.updateUser(uss);
PreparedStatement pst = (PreparedStatement)cmd.srv.us.db.getDb().prepareStatement("SELECT id, card, id_card FROM game ORDER BY RAND( ) LIMIT 0 , 1");
ResultSet rs = pst.executeQuery();
if (rs.next()) {
ss = ss + "  : " + rs.getString(2) + " , : " + rs.getInt(3) + " ()";
int reiting = uss.game + rs.getInt(3);
uss.game = reiting;
ss = ss + "  : " + uss.game + " ()";
cmd.srv.us.updateUser(uss);
proc.mq.add(uin, ss);
}
rs.close();
pst.execute();
pst.close();
return;
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, "  ");
}
}

public void commandVskrut(IcqProtocol proc, String uin, Vector v, String tmsg){
if((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
if(!(cmd.auth(proc, uin, "black_jack"))) {return;}
try {
int no = ((Integer)v.get(0)).intValue();
Users us = cmd.srv.us.getUser(uin);
Users uss = cmd.srv.us.getUser(no);
if((uss.room != cmd.psp.getIntProperty("roomkazino")) && (us.room != cmd.psp.getIntProperty("roomkazino")) && (uss.room != cmd.psp.getIntProperty("roomkazino"))) {
proc.mq.add(uin, "  -    " + cmd.psp.getIntProperty("roomkazino") + " ,      ..");
return;
}
if(uss == null){
proc.mq.add(uin, Messages.getString("ChatCommandProc.commandP.1"));
return;
}
if(!(cmd.srv.cq.testUser(uss.sn))){
proc.mq.add(uin, Messages.getString("ChatCommandProc.commandP.2"));
return;
}
if (uss.game == 0) {
proc.mq.add(uin, "       ,     ");
return;
}
if (us.game == 0) {
proc.mq.add(uin, "       -,     ");
return;
}
Log.talk("CHAT: " + uss.sn + ">>       " + cmd.srv.us.getUser(uin).localnick + ": ");
cmd.srv.us.db.log(uss.id, uin, "OUT", ">>       " + cmd.srv.us.getUser(uin).localnick + ": ", uss.room);
cmd.srv.getIcqProcess(uss.basesn).mq.add(uss.sn, "       " + cmd.srv.us.getUser(uin).localnick + ":     ! ...  ! .. ");
setgame(uss.sn, uin);
proc.mq.add(uin, "  ");
cmd.srv.us.updateUser(uss);
cmd.srv.us.updateUser(us);
} catch (Exception ex) {
ex.printStackTrace();
Log.talk(uin + " Private msg error: " + tmsg);
proc.mq.add(uin, Messages.getString("ChatCommandProc.commandP.6"));
}
}

public void commandPokazat(IcqProtocol proc, String uin, Vector v, String tmsg){
if((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
if(!(cmd.auth(proc, uin, "black_jack"))) {return;}
try {
String txt = (String)v.get(0);
String fsn1 = testgame(uin);
Users us = cmd.srv.us.getUser(uin);
int p = 0;
int e = 0;
if (txt.equals("")) {
proc.mq.add(uin, " ");
return;
}
if (fsn1.equals("")) {
proc.mq.add(uin, "   ,  ");
return;
}
Users uss = cmd.srv.us.getUser(fsn1);
if (uss == null) {
proc.mq.add(uin, "   ");
return;
}
if ((uss.room != cmd.psp.getIntProperty("roomkazino")) && (us.room != cmd.psp.getIntProperty("roomkazino")) && (uss.room != cmd.psp.getIntProperty("roomkazino"))) {
proc.mq.add(uin, "  -    " + cmd.psp.getIntProperty("roomkazino") + " ,      ..");
return;
}
if (!(cmd.srv.cq.testUser(uss.sn))) {
proc.mq.add(uin, "   ");
return;
}
if ((txt.equals("")) || (txt.equals(" ")) || ((!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))) && (!(txt.equals(""))))) {
proc.mq.add(uin, "   ");
return;
}
if ((txt.equals("")) || (txt.equals("")) || (txt.equals("")) || (txt.equals(""))){
p = 2;
Log.talk("CHAT: " + uss.sn + ">>      " + cmd.srv.us.getUser(uin).localnick + ": " + txt);
cmd.srv.us.db.log(uss.id, uin, "OUT", ">>      " + cmd.srv.us.getUser(uin).localnick + ": " + txt, uss.room);
cmd.srv.getIcqProcess(uss.basesn).mq.add(uss.sn, "     " + cmd.srv.us.getUser(uin).localnick + ": " + txt);
setgame(uss.sn, uin);
proc.mq.add(uin, " ");
int reiting1;
int reiting2;
if (p == 2){
int reiting3;
int reiting4;
if (uss.game == 21) {
reiting3 = uss.score + us.score;
uss.score = reiting3;
cmd.srv.us.updateUser(uss);
proc.mq.add(uss.sn, "... () 21 .....   " + uss.score + " $");
reiting4 = us.score = 0;
us.score = reiting4;
cmd.srv.us.updateUser(us);
reiting1 = uss.ball + uss.score;
uss.ball = reiting1;
reiting2 = uss.score = 0;
uss.score = reiting2;
cmd.srv.us.updateUser(uss);
}
if (us.game == 21) {
reiting3 = us.score + uss.score;
us.score = reiting3;
cmd.srv.us.updateUser(us);
proc.mq.add(us.sn, "... () 21 .....   " + us.score + " $");
reiting4 = uss.score = 0;
uss.score = reiting4;
cmd.srv.us.updateUser(uss);
reiting1 = us.ball + us.score;
us.ball = reiting1;
reiting2 = us.score = 0;
us.score = reiting2;
cmd.srv.us.updateUser(us);
}
}
if (us.game <= 21) {
proc.mq.add(us.sn, " " + us.localnick + "  " + us.game + " () ");
proc.mq.add(uss.sn, " " + us.localnick + "  " + us.game + " () ");
}
if (uss.game <= 21) {
proc.mq.add(uss.sn, " " + uss.localnick + "  " + uss.game + " () ");
proc.mq.add(us.sn, " " + uss.localnick + "  " + uss.game + " () ");
}
if ((uss.game > 21) && (us.game > 21)) {
proc.mq.add(uss.sn, " " + us.localnick + "  " + us.game + " () ");
proc.mq.add(us.sn, " " + uss.localnick + "  " + uss.game + " () ");
cmd.srv.cq.addMsg(" " + uss.localnick + "  " + us.localnick + "    21 ..,   ..", "", uss.room);
cmd.srv.cq.addMsg(" " + uss.localnick + "  " + us.localnick + "    21 ..,   ..", "", us.room);
int reiting6 = uss.game = 0;
uss.game = reiting6;
reiting2 = uss.score = 0;
uss.score = reiting2;
int reiting7 = us.game = 0;
us.game = reiting7;
int reiting3 = us.score = 0;
us.score = reiting3;
cmd.srv.us.updateUser(uss);
cmd.srv.us.updateUser(us);
return;
}
int reiting4;
int reiting5;
int reiting6 = 0;
int reiting7 = 0;
if (us.game > 21) {
reiting4 = uss.score + us.score;
uss.score = reiting4;
reiting5 = us.score = 0;
us.score = reiting5;
cmd.srv.us.updateUser(uss);
cmd.srv.us.updateUser(us);
proc.mq.add(uss.sn, " " + uss.localnick + " ..!!!  " + uss.score + " $");
proc.mq.add(us.sn, " " + uss.localnick + " ..!!!  " + uss.score + " $");
reiting1 = uss.ball + uss.score;
uss.ball = reiting1;
reiting2 = uss.score = 0;
uss.score = reiting2;
cmd.srv.us.updateUser(uss);
reiting6 = uss.game = 0;
uss.game = reiting6;
reiting7 = us.game = 0;
us.game = reiting7;
cmd.srv.us.updateUser(uss);
cmd.srv.us.updateUser(us);
return;
}
if (uss.game > 21) {
reiting4 = us.score + uss.score;
us.score = reiting4;
reiting5 = uss.score = 0;
uss.score = reiting5;
cmd.srv.us.updateUser(uss);
cmd.srv.us.updateUser(us);
proc.mq.add(us.sn, " " + us.localnick + " ..!!!  " + us.score + " $");
proc.mq.add(uss.sn, " " + us.localnick + " ..!!!  " + us.score + " $");
reiting1 = us.ball + us.score;
us.ball = reiting1;
reiting2 = us.score = 0;
us.score = reiting2;
cmd.srv.us.updateUser(us);
reiting6 = uss.game = 0;
uss.game = reiting6;
reiting7 = us.game = 0;
us.game = reiting7;
cmd.srv.us.updateUser(uss);
cmd.srv.us.updateUser(us);
return;
}
if (uss.game > us.game) {
reiting4 = uss.score + us.score;
uss.score = reiting4;
reiting5 = us.score = 0;
us.score = reiting5;
cmd.srv.us.updateUser(uss);
cmd.srv.us.updateUser(us);
proc.mq.add(uss.sn, " " + uss.localnick + " ..!!!  " + uss.score + " $");
proc.mq.add(us.sn, " " + uss.localnick + " ..!!!  " + uss.score + " $");
reiting1 = uss.ball + uss.score;
uss.ball = reiting1;
reiting2 = uss.score = 0;
uss.score = reiting2;
cmd.srv.us.updateUser(uss);
}
if (uss.game < us.game) {
reiting4 = us.score + uss.score;
us.score = reiting4;
reiting5 = uss.score = 0;
uss.score = reiting5;
cmd.srv.us.updateUser(uss);
cmd.srv.us.updateUser(us);
proc.mq.add(us.sn, " " + us.localnick + " ..!!!  " + us.score + " $");
proc.mq.add(uss.sn, " " + us.localnick + " ..!!!  " + us.score + " $");
reiting1 = us.ball + us.score;
us.ball = reiting1;
reiting2 = us.score = 0;
us.score = reiting2;
cmd.srv.us.updateUser(us);
}
if (uss.game == us.game) {
proc.mq.add(uss.sn, "  " + uss.localnick + "  " + us.localnick + "   ,   !! ");
reiting1 = uss.ball + uss.score;
uss.ball = reiting1;
reiting2 = uss.score = 0;
uss.score = reiting2;
cmd.srv.us.updateUser(uss);
proc.mq.add(us.sn, "  " + uss.localnick + "  " + us.localnick + "   ,   !! ");
int reiting3 = us.ball + us.score;
us.ball = reiting3;
reiting4 = us.score = 0;
us.score = reiting4;
cmd.srv.us.updateUser(us);
}
reiting6 = uss.game = 0;
uss.game = reiting6;
reiting7 = us.game = 0;
us.game = reiting7;
cmd.srv.us.updateUser(uss);
cmd.srv.us.updateUser(us);
}
else {
p = 0;
Log.talk("CHAT: " + uss.sn + ">>      " + cmd.srv.us.getUser(uin).localnick + ": " + txt);
cmd.srv.us.db.log(uss.id, uin, "OUT", ">>      " + cmd.srv.us.getUser(uin).localnick + ": " + txt, uss.room);
cmd.srv.getIcqProcess(uss.basesn).mq.add(uss.sn, "     " + cmd.srv.us.getUser(uin).localnick + ": " + txt);
setgame(uss.sn, uin);
proc.mq.add(uin, "  ");
}
} catch (Exception ex) {
ex.printStackTrace();
Log.talk(uin + " Private msg error: " + tmsg);
proc.mq.add(uin, "  "); }
}

private String testgame(String sn1) {
if (ub.get(sn1) == null) {
return "";
}
return ((String)ub.get(sn1));
}

private void setgame(String sn1, String from_sn1) {
ub.put(sn1, from_sn1);
}

}