/**
 * JimBot - Java IM Bot
 * Copyright (C) 2010 JimBot project
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package ru.jimbot.modules.chat;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.Vector;
import java.util.HashMap;
import ru.jimbot.modules.Cmd;
import ru.jimbot.protocol.IcqProtocol;
import ru.jimbot.modules.CommandParser;
import ru.jimbot.util.Log;
import ru.jimbot.util.PlainProp;

/**
 *  
 *  ChatCommandProc
 *
 * public MagHold mag;
 *
 * mag = new MagHold(this);
 *
 *  
 * if(mag.commandMagHold(proc, uin, mmsg)) return;
 *
 * @author  
 * @rewrite  
 */

public class MagHold {
private HashMap<String, Cmd> commands = new HashMap<String, Cmd>();
private CommandParser parser;
private ChatCommandProc cmd;

/**Creates a new instance of MagHold*/
public MagHold(ChatCommandProc c) {
parser = new CommandParser(commands);
cmd = c;
init();
}

private void init() {
commands.put("!", new Cmd("!", "$n", 1));
commands.put("!", new Cmd("!", "$n", 1));
commands.put("!", new Cmd("!", "$n", 1));
//commands.put("!", new Cmd("!", "$c",2));
commands.put("!", new Cmd("!", "$n", 3));
commands.put("!", new Cmd("!", "$n", 3));
commands.put("!", new Cmd("!", "$c", 4));
commands.put("!", new Cmd("!", "$s",5));
commands.put("!", new Cmd("!", "$n", 6));
commands.put("!", new Cmd("!", "$c", 7));
commands.put("!", new Cmd("!", "$s",9));
commands.put("!", new Cmd("!","$n",10));
commands.put("!vipsms", new Cmd("!vipsms", "$s",11));
commands.put("!", new Cmd("!", "$s",11));
}

public boolean commandMagHold(IcqProtocol proc, String uin, String tmsg) {
String msg = tmsg.trim();
int tp = parser.parseCommand(msg);
int tst=0;
if(tp<0) {
tst = 0;
} else {
tst = tp;
}
boolean f = true;
switch (tst) {
case 1:
commandHoldOrujie(proc, uin, tmsg, parser.parseArgs(tmsg));
break;
//case 2:
//commandHoldOrugieMag(proc, uin, tmsg, parser.parseArgs(tmsg));
//break;
case 3:
commandBomb(proc, uin, parser.parseArgs(tmsg));
break;
case 4:
commandUbomb(proc, uin, parser.parseArgs(tmsg));
break;
case 5:
commandGroupsTimesmsmoder(proc, uin, parser.parseArgs(tmsg));
break;
case 6:
commandring(proc, uin, parser.parseArgs(tmsg));
break;
case 7:
commandUring(proc, uin, parser.parseArgs(tmsg));
break;

case 9:
commandBall_Sms(proc, uin, parser.parseArgs(tmsg));
break;
case 10:
commandBankomat(proc, uin, parser.parseArgs(tmsg));
break;
case 11:
commandGroupsVip(proc, uin, parser.parseArgs(tmsg));
break;
default:
f = false;
break;
}
return f;
}

public void commandBankomat(IcqProtocol proc, String uin, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
if (!(cmd.auth(proc, uin, "game"))) {return;}
try{
int s = (Integer)v.get(0);
int num = (int) ((Math.random()*10));
Users uss = cmd.srv.us.getUser(uin);
String a1 =
cmd.radm.NICK()+":  <>:\n" +
"\n  -     $ !" +
"\n        -1  HP -1%!" +
"\n   1  10," +
"\n  ! 4" +
"\n ,  +1$   +1%HP";
int moder_id = uss.id; //  
if(uss.room!=cmd.psp.getIntProperty("bank.room")){
proc.mq.add(uin, cmd.radm.NICK()+":      " + cmd.psp.getIntProperty("bank.room") + "  " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("bank.room")).getName() + "");
return;
}
if(s<1 || s>10){
proc.mq.add(uin,a1);
return;
}
cmd.srv.cq.addMsg(cmd.radm.NICK()+":     : [" + num + "] ,  " + uss.localnick + " : [" + s + "] ", "", uss.room);
if(s==num){
int reiting = uss.hp+1;
uss.hp=reiting;
cmd.srv.us.updateUser(uss);
int newgender = uss.ball+1;
uss.ball = newgender;
cmd.srv.us.updateUser(uss);
cmd.srv.cq.addMsg(cmd.radm.NICK()+":  !*YAHOO* " + uss.localnick + " [ "+uss.id+"]     +1$   +1% !   " + uss.localnick + " [ "+uss.ball+"$]" + "  [ "+uss.hp+"%]", "", uss.room);
proc.mq.add(uin,cmd.radm.NICK()+":     : [" + num + "] ,   : [" + s + "] ,  !   !*YAHOO*   +1$  +1%!\n   [ "+uss.ball+"$]  [ "+uss.hp+"%]");
}else {
int reiting = uss.hp-1;
uss.hp=reiting;
cmd.srv.us.updateUser(uss);
int newgender = uss.ball-1;
uss.ball = newgender;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin,cmd.radm.NICK()+":     : [" + num + "] ,   : [" + s + "]\n        1$   1% !    [ "+uss.ball+"$]" + "  [ "+uss.country+"%]");
cmd.srv.cq.addMsg(cmd.radm.NICK()+":     : [" + num + "] ,  " + uss.localnick + " : [" + s + "].\n " + uss.localnick + " [ "+uss.id+"]       1$   1% !   " + uss.localnick + " [ "+uss.ball+"$]" + "  [ "+uss.hp+"%]", "", uss.room);
}
}catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}








public void commandUring(IcqProtocol proc, String uin, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
if (!(cmd.auth(proc, uin, "game"))) {return;}
if (!(cmd.psp.getBooleanProperty("chat.ring"))) {return;}
try {
String s = (String)v.get(0);
Users uss = cmd.srv.us.getUser(uin);
String ring = "ring";
if (uss.room != cmd.psp.getIntProperty("ring.room")){
proc.mq.add(uin,cmd.radm.NICK()+":    " + cmd.psp.getIntProperty("ring.room") + "  " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("ring.room")).getName() + "");
return;
}
if (!(cmd.mobi.containsKey(ring))){
proc.mq.add(uin, cmd.radm.NICK()+":    .");
return;
}
String t = ";;;";
String[] ss = t.split(";");
int R = (int)(Math.random() * ss.length);
int gold;
String c = ss[R];
if (s.equals(c)){
cmd.new_game_time = 0;
cmd.mobi.remove(ring);
gold = uss.ball + 10;
uss.ball = gold;
proc.mq.add(uin, cmd.radm.NICK()+":  .");
Log.talk(uss.sn + "-" + uss.localnick + "      10 ");
return;
}
int zdorov;
zdorov = uss.hp - cmd.psp.getIntProperty("ring.hp");
uss.hp=zdorov;
proc.mq.add(uin, "!!!!    " + c + ",   !!!   "+cmd.psp.getIntProperty("ring.hp")+"% ");
cmd.srv.cq.addMsg(" " + uss.localnick + "  " + c , uss.sn, uss.room);
cmd.new_game_time = 0;
cmd.mobi.remove(ring);
if (uss.hp - cmd.psp.getIntProperty("ring.hp")<0){
cmd.akick(proc, uin);
zdorov = uss.hp + cmd.psp.getIntProperty("ring.hp");
uss.hp=zdorov;
return;
}
Log.talk(uss.sn + "-" + uss.localnick + "   ");
}catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}

public void commandring(IcqProtocol proc, String uin, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
if (!(cmd.auth(proc, uin, "game"))) {return;}
if (!(cmd.psp.getBooleanProperty("chat.ring"))) {return;}
try {
int s = ((Integer)v.get(0)).intValue();
Users us = cmd.srv.us.getUser(s);
Users uss = cmd.srv.us.getUser(uin);
String ring = "ring";
if (uss.id == s){
proc.mq.add(uin, cmd.radm.NICK()+":    !!!");
return;
}
if (us.id == 0){
proc.mq.add(uin, cmd.radm.NICK()+":   .");
return;
}
if (us.room != uss.room){
proc.mq.add(uin,cmd.radm.NICK()+":           .");
return;
}
if (us.state != 2){
proc.mq.add(uin,cmd.radm.NICK()+":     .");
return;
}
if (cmd.mobi.containsKey(ring)){
proc.mq.add(uin,cmd.radm.NICK()+":     .");
return;
}
cmd.srv.us.updateUser(uss);
cmd.new_game_ring = System.currentTimeMillis();
cmd.mobi.put(ring, Integer.valueOf(us.id));
proc.mq.add(uin, cmd.radm.NICK()+":  .");
Log.talk(uss.sn + "-" + uss.localnick + "  "+ us.localnick);
cmd.srv.getIcqProcess(us.basesn).mq.add(us.sn,cmd.radm.NICK()+": " + uss.localnick + "  ,   5.     .:\n! \n! \n! \n! ");
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}

public void commandUbomb(IcqProtocol proc, String uin, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
if (!(cmd.auth(proc, uin, "game"))) {return;}
if (!(cmd.psp.getBooleanProperty("chat.bomba"))) {return;}
try {
String s = (String)v.get(0);
Users uss = cmd.srv.us.getUser(uin);
String bomba = "bomba";
if (!(cmd.mobi.containsKey(bomba))){
proc.mq.add(uin,cmd.radm.NICK()+":   .");
return;
}
String t = ";;";
String[] ss = t.split(";");
int R = (int)(Math.random() * ss.length);
int gold;
String c = ss[R];
if (s.equals(c)){
cmd.new_game_time = 0;
cmd.mobi.remove(bomba);
gold = uss.ball + 50;
uss.ball = gold;
proc.mq.add(uin,cmd.radm.NICK()+":  .");
Log.talk(uss.sn + "-" + uss.localnick + "       50 ");
return;
}
proc.mq.add(uin, "!!!!   " + c + ",  @= .   "+cmd.psp.getIntProperty("granata.uron.hp")+ " % !!");
cmd.new_game_time = 0;
cmd.mobi.remove(bomba);
int jizn =uss.hp - cmd.psp.getIntProperty("granata.uron.hp");
uss.hp =jizn;
int timer = cmd.psp.getIntProperty("chat.BombTimer");
cmd.tkick(proc, uin, timer, 0, "     !");

Log.talk(uss.sn + "-" + uss.localnick + "    ");
}catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}

public void commandBomb(IcqProtocol proc, String uin, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
if (!(cmd.auth(proc, uin, "game"))) {return;}
if (!(cmd.psp.getBooleanProperty("chat.bomba"))) {return;}
try {
int s = ((Integer)v.get(0)).intValue();
Users us = cmd.srv.us.getUser(s);
Users uss = cmd.srv.us.getUser(uin);
String bomba = "bomba";

if (cmd.psp.getBooleanProperty("room_str.on.off")){
if (us.room != cmd.psp.getIntProperty("room.str")){
proc.mq.add(uin, "    " + cmd.psp.getIntProperty("room.str") + "  " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("room.str")).getName() + "");
return;
}
}
if (cmd.psp.getBooleanProperty("room_str.no.off")){
if (us.room == cmd.psp.getIntProperty("room.no.str")){
proc.mq.add(uin, "   " + cmd.psp.getIntProperty("room.no.str") + "  " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("room.no.str")).getName() + "");
return;
}
}
if (cmd.psp.getBooleanProperty("war.clan.on.off")){
if(us.clansman == uss.clansman && us.clansman!=0 && uss.clansman!=0)
{
proc.mq.add(uin, cmd.radm.NICK()+": "+ uss.localnick + "       ." );
return;
}
    }
if (cmd.psp.getBooleanProperty("imm.on.off")){
if (us.number == 1){
proc.mq.add(uin, cmd.radm.NICK()+": "+ us.localnick+"  .    !!");
cmd.srv.getIcqProcess(us.basesn).mq.add(us.sn, uss.localnick + ", " + "()       .");
return;
}
    }
if (uss.id == s){
proc.mq.add(uin,cmd.radm.NICK()+":    !!!");
return;
}
if (us.id == 0){
proc.mq.add(uin,cmd.radm.NICK()+":   .");
return;
}
if (us.room != uss.room){
proc.mq.add(uin,cmd.radm.NICK()+":           .");
return;
}
if (us.state != 2){
proc.mq.add(uin,cmd.radm.NICK()+":     .");
return;
}
if (uss.bomba < 1){
proc.mq.add(uin,cmd.radm.NICK()+":    .");
return;
}
if (cmd.mobi.containsKey(bomba)){
proc.mq.add(uin,cmd.radm.NICK()+":     .");
return;
}
uss.bomba -= 1;
cmd.srv.us.updateUser(uss);
cmd.new_game_time = System.currentTimeMillis();
cmd.mobi.put(bomba, Integer.valueOf(us.id));
proc.mq.add(uin,cmd.radm.NICK()+":  @= .");
Log.talk(uss.sn + "-" + uss.localnick + "   " + us.localnick);
cmd.srv.getIcqProcess(us.basesn).mq.add(us.sn,cmd.radm.NICK()+": " + uss.localnick + "    @=,  30.    : ,  . ! \"\",  .");
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}

/**
 *  
 * @param proc
 * @param uin
 * @param tmsg
 * @param v
 */
public void commandHoldOrujie(IcqProtocol proc, String uin, String tmsg, Vector v) {
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
if (!(cmd.auth(proc, uin, "game"))) {return;}
try {
int g = (int)(Math.random() * 5.0);
int i = ((Integer)v.get(0)).intValue();
Users u = cmd.srv.us.getUser(i);
Users us = cmd.srv.us.getUser(uin);
int stv = us.holodnoe;
if (cmd.psp.getBooleanProperty("room_hold.on.off")){
if (us.room != cmd.psp.getIntProperty("room.hold")){
proc.mq.add(uin, cmd.radm.NICK()+":     " + cmd.psp.getIntProperty("room.hold") + "  " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("room.hold")).getName() + "");
return;
}

if (cmd.psp.getBooleanProperty("war.clan.on.off")){
if(us.clansman == u.clansman && u.clansman!=0 && us.clansman!=0)
{
proc.mq.add(uin, cmd.radm.NICK()+": "+ us.localnick + "        ." );
return;
}
    }
if (cmd.psp.getBooleanProperty("imm.on.off")){
if (u.number == 1){
proc.mq.add(uin, cmd.radm.NICK()+": "+ u.localnick+"  .    !!");
cmd.srv.getIcqProcess(u.basesn).mq.add(u.sn, us.localnick + ", " + "()   ,     .");
return;
}
    }
if (cmd.psp.getBooleanProperty("immm.on.off")){
if (u.holodnoe == 0 && u.orujie == 0) {
proc.mq.add(uin,"  ,   !");
return;
}
    }
}
if (u.id == 0) {
proc.mq.add(uin,cmd.radm.NICK()+":   ");
return;
}
if (u.state == 1) {
proc.mq.add(uin,cmd.radm.NICK()+":    ");
return;
}
if (us.room != u.room) {
proc.mq.add(uin,cmd.radm.NICK()+":    ");
return;
}

int op;
int gold;
int gold2;
int hp;


if (us.holodnoe > 0) {

if (u.hp >= PlainProp.getInstance(cmd.srv.getName()).getHealth(stv)){
       op = us.age + g;
us.age = op;
hp = u.hp - PlainProp.getInstance(cmd.srv.getName()).getHealth(stv);
u.hp = hp;
gold = u.ball - PlainProp.getInstance(cmd.srv.getName()).getPurse(stv);
u.ball = gold;
gold2 = us.ball + PlainProp.getInstance(cmd.srv.getName()).getReward(stv);
us.ball = gold2;

cmd.srv.us.updateUser(u);
cmd.srv.us.updateUser(us);
proc.mq.add(uin, "   " + u.localnick + "  "+PlainProp.getInstance(cmd.srv.getName()).getName(stv)+".     "+ PlainProp.getInstance(cmd.srv.getName()).getReward(stv)+ " " + cmd.psp.getStringProperty("valuta.chat") + " ,    "+PlainProp.getInstance(cmd.srv.getName()).getHealth(stv)+"   "+PlainProp.getInstance(cmd.srv.getName()).getPurse(stv)+ " " + cmd.psp.getStringProperty("valuta.chat"));
cmd.srv.getIcqProcess(u.basesn).mq.add(u.sn, u.localnick + ", " + "  "+PlainProp.getInstance(cmd.srv.getName()).getName(stv)+" " + us.localnick + "   "+PlainProp.getInstance(cmd.srv.getName()).getHealth(stv)+"   "+PlainProp.getInstance(cmd.srv.getName()).getPurse(stv)+ " " + cmd.psp.getStringProperty("valuta.chat"));
return;
    }


if(u.hp < PlainProp.getInstance(cmd.srv.getName()).getHealth(stv)) {
if (cmd.psp.getBooleanProperty("hospital.on.off")){
int goldhelp = u.hp+cmd.psp.getIntProperty("hospital.zdorove");
u.hp=goldhelp;
//cmd.radm.say(u.localnick + "       " + cmd.psp.getIntProperty("time.help") + " ", u.sn);
u.room = cmd.psp.getIntProperty("room.hospital");
cmd.radm.srv.cq.changeUserRoom(u.sn, cmd.psp.getIntProperty("room.hospital"));
cmd.radm.say("  , : " + u.localnick, cmd.psp.getIntProperty("room.hospital"));
cmd.radm.srv.us.revokeUser(u.id, "room");
u.lastclosed = System.currentTimeMillis() + cmd.psp.getIntProperty("time.help") * 60000;
cmd.radm.srv.us.updateUser(u);
cmd.radm.srv.getIcqProcess(u.basesn).mq.add(u.sn,"!!!  ! "+u.localnick + "       " + cmd.psp.getIntProperty("time.help") + " ");
 proc.mq.add(uin, "   " + u.localnick + ".     ()  ");
}
}
    }

//if (us.holodnoe == 2) {
//op = us.age + g;
//us.age = op;
//if (u.hp > cmd.psp.getIntProperty("uron.hp.nog")){
//hp = u.hp - cmd.psp.getIntProperty("uron.hp.nog");
//u.hp = hp;
//gold = u.ball - cmd.psp.getIntProperty("uron.money.nog");
//u.ball = gold;
//gold2 = us.ball + cmd.psp.getIntProperty("give.money.nog");
//us.ball = gold2;
//cmd.srv.us.updateUser(u);
//proc.mq.add(uin, "  " + u.localnick + "   .     "+cmd.psp.getIntProperty("give.money.nog")+ " " + cmd.psp.getStringProperty("valuta.chat") +" ,    "+cmd.psp.getIntProperty("uron.hp.nog")+"   "+cmd.psp.getIntProperty("uron.money.nog")+ " " + cmd.psp.getStringProperty("valuta.chat"));
//cmd.srv.getIcqProcess(u.basesn).mq.add(u.sn, u.localnick + ", " + "    " + us.localnick + "   "+cmd.psp.getIntProperty("uron.hp.nog")+"   "+cmd.psp.getIntProperty("uron.money.nog")+ " " + cmd.psp.getStringProperty("valuta.chat"));
//return;
//}
//return;
//}





} catch (Exception ex) {
ex.printStackTrace();
  proc.mq.add(uin, "   .   !!!");
}
}

//public void commandHoldOrugieMag(IcqProtocol proc, String uin, String tmsg, Vector v){
//if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) {return;}
//if (!(cmd.auth(proc, uin, "game"))) {return;}
//try {
//String dol = (String)v.get(0);
//Users uss = cmd.srv.us.getUser(uin);
//if ((uss.room != cmd.psp.getIntProperty("orugie.room"))){
//proc.mq.add(uin, "     [" + cmd.psp.getIntProperty("orugie.room") + "] " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("orugie.room")).getName() + "" );
//return;
//}
//int uroven5;
//int gold;
//int uroven;
//String gold3;
//if (dol.equals("1")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.rem")){
//proc.mq.add(uin, " : " + uss.ball +  " " + cmd.psp.getStringProperty("valuta.chat")+" ,      .");
//return;
//}
//uroven5 = uss.holodnoe = 1;
//uss.holodnoe = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.rem");
//uss.ball = gold;
//uroven = uss.age + 1;
//uss.age = uroven;
//gold3 = uss.hold_org = "";
//uss.hold_org = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,   .::.  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat") +".     "+cmd.psp.getIntProperty("orugie.rem"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " () .::.", uss.sn, uss.room);
//}else
//if (dol.equals("3")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.sumka")){
//proc.mq.add(uin, " : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+ ",      .");
//return;
//}
//uroven5 = uss.holodnoe = 3;
//uss.holodnoe = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.sumka");
//uss.ball = gold;
//uroven = uss.age + 3;
//uss.age = uroven;
//gold3 = uss.hold_org = " ";
//uss.hold_org = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,   .: :.  : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat") +".     "+cmd.psp.getIntProperty("orugie.sumka"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " () .: :.", uss.sn, uss.room);
//}else
//if (dol.equals("4")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.kuvalda")){
//proc.mq.add(uin, " : " + uss.ball +  " " + cmd.psp.getStringProperty("valuta.chat")+" ,      .");
//return;
//}
//uroven5 = uss.holodnoe = 4;
//uss.holodnoe = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.kuvalda");
//uss.ball = gold;
//uroven = uss.age + 4;
//uss.age = uroven;
//gold3 = uss.hold_org = "";
//uss.hold_org = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,   .::.  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat") +".     "+cmd.psp.getIntProperty("orugie.kuvalda"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " () .::.", uss.sn, uss.room);
//}else
//if (dol.equals("5")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.povar")){
//proc.mq.add(uin, " : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.holodnoe = 5;
//uss.holodnoe = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.povar");
//uss.ball = gold;
//uroven = uss.age + 5;
//uss.age = uroven;
//gold3 = uss.hold_org = "";
//uss.hold_org = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,   .::.  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orugie.povar"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " () .::.", uss.sn, uss.room);
//}else
//if (dol.equals("6")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.sapogi")){
//proc.mq.add(uin, " : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.holodnoe = 6;
//uss.holodnoe = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.sapogi");
//uss.ball = gold;
//uroven = uss.age + 6;
//uss.age = uroven;
//gold3 = uss.hold_org = "";
//uss.hold_org = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,   .::.  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orugie.sapogi"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " () .::.", uss.sn, uss.room);
//}else
//if (dol.equals("7")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.scalka")){
//proc.mq.add(uin, " : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.holodnoe = 7;
//uss.holodnoe = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.scalka");
//uss.ball = gold;
//uroven = uss.age + 7;
//uss.age = uroven;
//gold3 = uss.hold_org = "";
//uss.hold_org = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,   .::.  : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat") +".     "+cmd.psp.getIntProperty("orugie.scalka"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " () .::.", uss.sn, uss.room);
//}else
//if (dol.equals("2")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.nog")){
//proc.mq.add(uin, " : " + uss.ball +  " " + cmd.psp.getStringProperty("valuta.chat")+" ,      .");
//return;
//}
//uroven5 = uss.holodnoe = 2;
//uss.holodnoe = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.nog");
//uss.ball = gold;
//uroven = uss.age + 2;
//uss.age = uroven;
//gold3 = uss.hold_org = "";
//uss.hold_org = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,   .::.  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat") +".     "+cmd.psp.getIntProperty("orugie.nog"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " () .::.", uss.sn, uss.room);
//}else{
//proc.mq.add(uin,
//" :" +
//"\n[] -    " +
//"\n[1] - .::.  " + cmd.psp.getIntProperty("orugie.rem") +
//"\n[2] - .::.  " + cmd.psp.getIntProperty("orugie.nog")+
//"\n[3] - .: :.  " + cmd.psp.getIntProperty("orugie.sumka") +
//"\n[4] - .::.  " + cmd.psp.getIntProperty("orugie.kuvalda") +
//"\n[5] - .::.   " + cmd.psp.getIntProperty("orugie.povar") +
//"\n[6] - .::.  " + cmd.psp.getIntProperty("orugie.sapogi") +
//"\n[7] - .::.  " + cmd.psp.getIntProperty("orugie.scalka")) ;
//
//}
//}
//catch (Exception ex) {
//ex.printStackTrace();
//proc.mq.add(uin, " " + ex.getMessage()); }
//}
////**************************************************

/**
 * ! pass -     
 * @author REDOSS
 * @param proc
 * @param uin
 * @param v
 * @param mmsg
 */
public void commandGroupsTimesmsmoder(IcqProtocol proc, String uin, Vector v){
if(!cmd.isChat(proc, uin) && !cmd.psp.testAdmin(uin)) {return;}
if(!cmd.auth(proc, uin, "group_moder_sms")) {return;}
try {
String pass = (String)v.get(0);
Users u = cmd.srv.us.getUser(uin);
int num = 0;
int day = cmd.psp.getIntProperty("sms.moder.day");
if (pass.equals("")){
proc.mq.add(uin," . "+ cmd.psp.getStringProperty("sms.txt"));
return;
}
//  
PreparedStatement pst = (PreparedStatement) cmd.srv.us.db.getDb().prepareStatement("SELECT `id` FROM pravasms WHERE `txt` = ?  ");
pst.setString(1,pass);
ResultSet rs = pst.executeQuery();
if(rs.next()){
num = rs.getInt(1);
} else {
proc.mq.add(uin," ");
return;
}
rs.close();
pst.close();
cmd.setGrouptimes(u.sn,day);
cmd.srv.us.getUser(uin).group = "moder";
cmd.srv.us.getUser(uin).sms = 1;
boolean groupp = cmd.srv.us.setUserPropsValue(u.id, "group", "moder") &&
cmd.srv.us.setUserPropsValue(u.id, "grant", "") &&
cmd.srv.us.setUserPropsValue(u.id, "revoke", "");
cmd.srv.us.clearCashAuth(u.id);
//  
String q = "DELETE FROM pravasms WHERE id="+num+" LIMIT 1";
PreparedStatement pst2 = (PreparedStatement) cmd.srv.us.db.getDb().prepareStatement(q);
pst2.execute();
pst2.close();
cmd.srv.us.updateUser(u);
proc.mq.add(uin,"      " + cmd.psp.getIntProperty("sms.moder.day") + " ()");
cmd.srv.cq.addMsg(" " + u.localnick + "|" + u.id + "|     " + cmd.psp.getIntProperty("sms.moder.day") + " ()", "", u.room);
} catch (Exception ex){
ex.printStackTrace();
proc.mq.add(uin," " + ex.getMessage());
}
}


/**
 * ! pass -     
 * @author REDOSS
 * @param proc
 * @param uin
 * @param v
 * @param mmsg
 */
public void commandGroupsVip(IcqProtocol proc, String uin, Vector v){
if(!cmd.isChat(proc, uin) && !cmd.psp.testAdmin(uin)) {return;}
if(!cmd.auth(proc, uin, "group_vip_sms")) {return;}
try {
String pass = (String)v.get(0);
Users u = cmd.srv.us.getUser(uin);
int num = 0;
if (pass.equals("")){
proc.mq.add(uin," . "+ cmd.psp.getStringProperty("sms.vip.txt"));
return;
}
//  
PreparedStatement pst = (PreparedStatement) cmd.srv.us.db.getDb().prepareStatement("SELECT `id` FROM smsvip WHERE `txt` = ?  ");
pst.setString(1,pass);
ResultSet rs = pst.executeQuery();
if(rs.next()){
num = rs.getInt(1);
} else {
proc.mq.add(uin," ");
return;
}
rs.close();
pst.close();

cmd.srv.us.getUser(uin).group = "vip";
cmd.srv.us.getUser(uin).sms = 1;
boolean groupp = cmd.srv.us.setUserPropsValue(u.id, "group", "vip") &&
cmd.srv.us.setUserPropsValue(u.id, "grant", "") &&
cmd.srv.us.setUserPropsValue(u.id, "revoke", "");
cmd.srv.us.clearCashAuth(u.id);
//  
String q = "DELETE FROM pravasms WHERE id="+num+" LIMIT 1";
PreparedStatement pst2 = (PreparedStatement) cmd.srv.us.db.getDb().prepareStatement(q);
pst2.execute();
pst2.close();
cmd.srv.us.updateUser(u);
proc.mq.add(uin,"   vip");
cmd.srv.cq.addMsg(" " + u.localnick + "|" + u.id + "|  vip ", "", u.room);
} catch (Exception ex){
ex.printStackTrace();
proc.mq.add(uin," " + ex.getMessage());
}
}

public void commandBall_Sms(IcqProtocol proc, String uin, Vector v){
if(!cmd.isChat(proc, uin) && !cmd.psp.testAdmin(uin)) {return;}
if(!cmd.auth(proc, uin, "smsbiling")) {return;}
try {
String pass = (String)v.get(0);
Users u = cmd.srv.us.getUser(uin);
int num = 0;
int gold;
if (pass.equals("")){
proc.mq.add(uin," . "+ cmd.psp.getStringProperty("sms.ball.txt"));
return;
}
//  
PreparedStatement pst = (PreparedStatement) cmd.srv.us.db.getDb().prepareStatement("SELECT `id` FROM ball_sms WHERE `txt` = ?  ");
pst.setString(1,pass);
ResultSet rs = pst.executeQuery();
if(rs.next()){
num = rs.getInt(1);
} else {
proc.mq.add(uin," ");
return;
}
rs.close();
pst.close();
gold = u.ball + cmd.psp.getIntProperty("sms.ball");
u.ball = gold;
//  
String q = "DELETE FROM ball_sms WHERE id="+num+" LIMIT 1";
PreparedStatement pst2 = (PreparedStatement) cmd.srv.us.db.getDb().prepareStatement(q);
pst2.execute();
pst2.close();
cmd.srv.us.updateUser(u);
int b = cmd.psp.getIntProperty("sms.ball");
proc.mq.add(uin,"   "+b+" ()");
cmd.srv.cq.addMsg(" " + u.localnick + "|" + u.id + "|  "+b+" ()", "", u.room);
} catch (Exception ex){
ex.printStackTrace();
proc.mq.add(uin," " + ex.getMessage());
}
}

}