package ru.jimbot.util;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.HashSet;
import java.util.Properties;
import java.util.Vector;

import ru.jimbot.table.UserPreference;

/**
 *   
 *
 * @author Prolubnikov Dmitry
 */
public class MainProps {
   public static final String VERSION = "ADMIN EDITION GAME (1.07.11)";

    public static final int VER_INT = 18;
//    public static final String VER_DESC ="test version";
    private static int ver_no = 0;
    private static long ver_last_read = 0;
    private static String ver_desc = "";
//    public static final String VER_DESC = "       MySQL;" +
//    		" ;" +
//    		"";
    public static final String PROG_TITLE = "jImBot";
    public static final String PROPS_FILE = "./jimbot.xml";
    public static final String ENCODING = "windows-1251";
    private static Properties appProps;
    private static Properties langProps;
    private static boolean isLoaded = false;
    private static Vector servers = new Vector();
    private static String currentServer = "";
    private static int currentPort = 0;
    private static int countServer = 0;
    private static HashSet<String> ignor;
    private static HashSet<String> ignorIP;

    /** Creates a new instance of MainProps */
    public MainProps() {
    }

    public static final void setDefault() {
        appProps = new Properties();
        setStringProperty("icq.serverDefault","login.icq.com");
        setIntProperty("icq.portDefault",5190);
        setStringProperty("main.logLevel","INFO");
    setBooleanProperty("main.useConsoleLog",true);
        setBooleanProperty("main.useTray",true);
        setStringProperty("main.Socks5ProxyHost","");
        setStringProperty("main.Socks5ProxyPort","");
        setStringProperty("main.Socks5ProxyUser","");
        setStringProperty("main.Socks5ProxyPass","");
        setBooleanProperty("main.autoStart",true);
        setIntProperty("icq.AUTORETRY_COUNT",5);
        setBooleanProperty("icq.md5login",false);
//        setStringProperty("main.dbType","MYSQL");
//        setStringProperty("db.host","localhost:3306");
//        setStringProperty("db.user","root");
//        setStringProperty("db.pass","");
//        setStringProperty("db.dbname","botdb");
        setBooleanProperty("main.StartHTTP",true);
        setStringProperty("http.user","admin"); //   
        setStringProperty("http.pass","admin"); //     
        setIntProperty("http.delay",10);
        setIntProperty("http.maxErrLogin",3);
        setIntProperty("http.timeErrLogin",10);
        setIntProperty("http.timeBlockLogin",20);
        setIntProperty("srv.servicesCount",1);

        setBooleanProperty("main.checkNewVer", true);

        setStringProperty("css.texts","000000");
        setStringProperty("css.a10","de3163");
        setStringProperty("css.a20","2a52be");
        setStringProperty("css.cat","ff2400");
        setStringProperty("bg.color","f6f4e9");
        setStringProperty("bg.image","http://www.walls-world.ru/wallpapers/3d/wallpapers_406_1280x1024.jpg");
        setStringProperty("main.hoz_uin","111111;222222");
        setStringProperty("nebolsjoytext","<br><br>");
setStringProperty("db.main.user","root");
        setStringProperty("db.pass","");

                setStringProperty("botip","");
                setBooleanProperty("billing.main.on.off", true);

                setBooleanProperty("billing.x.on.off", false);
                setIntProperty("timeOut",4);
        setBooleanProperty("pause.uin.on.off", false);
           setBooleanProperty("pause.servise.on.off", false);


           //  
setIntProperty("textarea.cols", 100);
setIntProperty("textarea.rows", 20);

    }

    public static UserPreference[] getUserPreference(){
        UserPreference[] p = {

             new UserPreference(UserPreference.STRING_TYPE,"nebolsjoytext"," ",getStringProperty("nebolsjoytext")),

             new UserPreference(UserPreference.STRING_TYPE,"main.hoz_uin","     ",getStringProperty("main.hoz_uin")),
            new UserPreference(UserPreference.CATEGORY_TYPE,"bezop", " ",""),
            new UserPreference(UserPreference.STRING_TYPE,"http.user","  ",getStringProperty("http.user")),
            new UserPreference(UserPreference.STRING_TYPE,"http.pass","    ",getStringProperty("http.pass")),
            new UserPreference(UserPreference.BOOLEAN_TYPE,"main.StartHTTP"," HTTP ",getBooleanProperty("main.StartHTTP")),
            new UserPreference(UserPreference.INTEGER_TYPE,"http.delay","  HTTP ",getIntProperty("http.delay")),
            new UserPreference(UserPreference.INTEGER_TYPE,"http.maxErrLogin","    ",getIntProperty("http.maxErrLogin")),
            new UserPreference(UserPreference.INTEGER_TYPE,"http.timeErrLogin","   ",getIntProperty("http.timeErrLogin")),
            new UserPreference(UserPreference.INTEGER_TYPE,"http.timeBlockLogin","  ",getIntProperty("http.timeBlockLogin")),
            new UserPreference(UserPreference.CATEGORY_TYPE,"main", " ",""),
           // new UserPreference(UserPreference.STRING_TYPE,"about","  !",getStringProperty("about")),
            new UserPreference(UserPreference.BOOLEAN_TYPE,"main.checkNewVer","   ",getBooleanProperty("main.checkNewVer")),
           new UserPreference(UserPreference.STRING_TYPE,"main.logLevel", "  ",getStringProperty("main.logLevel"),new String[]{"INFO","WARN","DEBUG","ERROR","FATAL","TRACE","ALL"}),
          // new UserPreference(UserPreference.STRING_TYPE,"main.dbType", "  ",getStringProperty("main.dbType"),new String[]{"HSQLDB","MYSQL"}),
           new UserPreference(UserPreference.BOOLEAN_TYPE,"main.useConsoleLog","   ",getBooleanProperty("main.useConsoleLog")),
            new UserPreference(UserPreference.BOOLEAN_TYPE,"main.useTray","  ",getBooleanProperty("main.useTray")),
          new UserPreference(UserPreference.BOOLEAN_TYPE,"main.autoStart","  ",getBooleanProperty("main.autoStart")),
           new UserPreference(UserPreference.CATEGORY_TYPE,"main", " ",""),
            new UserPreference(UserPreference.STRING_TYPE,"main.Socks5ProxyHost"," ",getStringProperty("main.Socks5ProxyHost")),
           new UserPreference(UserPreference.STRING_TYPE,"main.Socks5ProxyPort"," ",getStringProperty("main.Socks5ProxyPort")),
        new UserPreference(UserPreference.STRING_TYPE,"main.Socks5ProxyUser"," ",getStringProperty("main.Socks5ProxyUser")),
         new UserPreference(UserPreference.STRING_TYPE,"main.Socks5ProxyPass"," ",getStringProperty("main.Socks5ProxyPass")),
          new UserPreference(UserPreference.CATEGORY_TYPE,"bot", " ",""),
             new UserPreference(UserPreference.CATEGORY_TYPE,"connect", " ",""),
           new UserPreference(UserPreference.STRING_TYPE,"icq.serverDefault","ICQ  1",getStringProperty("icq.serverDefault")),
            new UserPreference(UserPreference.INTEGER_TYPE,"icq.portDefault","ICQ  1",getIntProperty("icq.portDefault")),
           new UserPreference(UserPreference.BOOLEAN_TYPE,"icq.md5login"," ",getBooleanProperty("icq.md5login")),


         new UserPreference(UserPreference.BOOLEAN_TYPE,"pause.uin.on.off"," uin'  ",getBooleanProperty("pause.uin.on.off")),


             new UserPreference(UserPreference.INTEGER_TYPE,"timeOut","   UINs (.)",getIntProperty("timeOut")),
             new UserPreference(UserPreference.BOOLEAN_TYPE,"pause.servise.on.off","   (  )",getBooleanProperty("pause.servise.on.off")),


            new UserPreference(UserPreference.CATEGORY_TYPE,"bots", " WEB-",""),
            new UserPreference(UserPreference.STRING_TYPE,"css.texts","  #",getStringProperty("css.texts")),
            new UserPreference(UserPreference.STRING_TYPE,"css.a10","    #",getStringProperty("css.a10")),
            new UserPreference(UserPreference.STRING_TYPE,"css.a20","   #",getStringProperty("css.a20")),
            new UserPreference(UserPreference.STRING_TYPE,"css.cat","    #",getStringProperty("css.cat")),

             new UserPreference(UserPreference.STRING_TYPE,"bg.color","  #",getStringProperty("bg.color")),


            new UserPreference(UserPreference.STRING_TYPE,"bg.image","Url  ",getStringProperty("bg.image")),
         new UserPreference(UserPreference.CATEGORY_TYPE,"db_create", "   ",""),
new UserPreference(UserPreference.STRING_TYPE,"db.main.user","(root)",getStringProperty("db.main.user")),



          new UserPreference(UserPreference.PASS_TYPE,"db.pass"," root`a",getStringProperty("db.pass")),

   new UserPreference(UserPreference.CATEGORY_TYPE,"billing.main.on.off", "    ",""),
         new UserPreference(UserPreference.BOOLEAN_TYPE,"billing.main.on.off","/",getBooleanProperty("billing.main.on.off")),


             //      
new UserPreference(UserPreference.CATEGORY_TYPE,"bots", " TEXTAREA", true),
new UserPreference(UserPreference.INTEGER_TYPE,"textarea.cols","   -    (COLS)",getIntProperty("textarea.cols")),
new UserPreference(UserPreference.INTEGER_TYPE,"textarea.rows","  ,    (ROWS)",getIntProperty("textarea.rows")),

        };
        return p;
    }

    /**
     *  -  
     */
    public static void loadIgnorList(){
    	String s;
    	ignor = new HashSet<String>();
        try{
            BufferedReader r = new BufferedReader(new InputStreamReader(new FileInputStream("ignore.txt"),"windows-1251"));
            while (r.ready()){
                s = r.readLine();
                if(!s.equals("")){
                    ignor.add(s);
                }
            }
            r.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
    }

    /**
     *   ?
     * @param uin
     * @return
     */
    public static boolean isIgnor(String uin){
    	if(ignor==null) return false;
    	return ignor.contains(uin);
    }

    public static Properties getProps(){
        return appProps;
    }

    public static int getServicesCount(){
    	return getIntProperty("srv.servicesCount");
    }

    public static String getServiceName(int i){
    	return getStringProperty("srv.serviceName"+i);
    }

    public static String getServiceType(int i) {
    	return getStringProperty("srv.serviceType"+i);
    }

    public static int addService(String name, String type){
    	int c = getServicesCount();
    	setIntProperty("srv.servicesCount", c+1);
    	setStringProperty("srv.serviceName"+c, name);
    	setStringProperty("srv.serviceType"+c, type);
    	return c;
    }

    public static void delService(String name) {
    	//       
    	boolean f = false;
    	for(int i=0; i<(getServicesCount()-1); i++){
    		if(getServiceName(i).equals(name))
    			f = true;
    		if(f){
    			setStringProperty("srv.serviceName"+i, getServiceName(i+1));
    			setStringProperty("srv.serviceType"+i, getServiceType(i+1));
    		}
    	}
    	//   
    	appProps.remove("srv.serviceName"+(getServicesCount()-1));
    	appProps.remove("srv.serviceType"+(getServicesCount()-1));
    	setIntProperty("srv.servicesCount", getServicesCount()-1);
    }

//    public static boolean isExtdb(){
//        return !getStringProperty("main.dbType").equals("HSQLDB");
//    }

    public static String getServer() {
        if(currentServer.equals(""))
            currentServer = getStringProperty("icq.serverDefault");
        return currentServer;
    }

    public static int getPort(){
        if(currentPort==0)
            currentPort = getIntProperty("icq.portDefault");
        return currentPort;
    }

    public static void nextServer(){
        if(servers.size()==0) return;
        countServer++;
        if(countServer>=servers.size()) countServer=0;
        String s = servers.get(countServer).toString();
        if(s.indexOf(":")<0){
            currentPort = getIntProperty("icq.portDefault");
            currentServer = s;
        } else{
            currentPort = Integer.parseInt(s.split(":")[1]);
            currentServer = s.split(":")[0];
        }
    }

    /**
     *   ICQ   
     */
    public static void loadServerList(){
        String s;
        try{
            BufferedReader r = new BufferedReader(new InputStreamReader(new FileInputStream("servers.txt"),"windows-1251"));
            while (r.ready()){
                s = r.readLine();
                if(!s.equals("")){
                    servers.add(s);
                }
            }
            r.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
    }

    public static boolean isProxy(){
        return !getStringProperty("main.Socks5ProxyHost").equals("");
    }

    public static String[] getProxy(){
//      return new String[] {"192.168.0.1","1080","admin","rtyuehe"};
        String[] s = new String[4];
        s[0] = getStringProperty("main.Socks5ProxyHost");
        s[1] = getStringProperty("main.Socks5ProxyPort");
        if(s[1].equals("")){
            s[1] = "0";
        }
        s[2] = getStringProperty("main.Socks5ProxyUser");
        s[3] = getStringProperty("main.Socks5ProxyPass");
        return s;
    }

    public static String getAbout(){
        String b = getStringProperty("nebolsjoytext");
b = b.replace("<br>", "\n");
        return PROG_TITLE + " " + VERSION +"\n" +b+"\n" +
               // getStringFromHTTP("http://globalme.ru/mod.txt");

":\n\n" +

"(c)WARIK\n" +
" ICQ#: 358566330\n" +
" http://WARIK777.RU\n\n" +

"(c)dim@X\n" +
" ICQ#: 963737\n" +
" http://GLOBALME.RU\n" +
"";


    }
    public static boolean isHide(){
        return Boolean.valueOf(getProperty("isHide","true")).booleanValue();
    }


    public static final void load() {
        String fileName = PROPS_FILE;
        File file = new File(fileName);
        setDefault();
        loadIgnorList();
        try {
            FileInputStream fi = new FileInputStream(file);
//            appProps.load(fi);
            appProps.loadFromXML(fi);
            fi.close();
            Log.info("Load preferences ok");
            loadServerList();
        } catch (Exception ex) {
            ex.printStackTrace();
            Log.error("Error opening preferences: ");
        }
    }

    public static final void save() {
        String fileName = PROPS_FILE;
        File file = new File(fileName);
        try {
            FileOutputStream fo = new FileOutputStream(file);
//            appProps.store(fo,"jImBot properties");
            appProps.storeToXML(fo, "jImBot properties");
            fo.close();
            Log.info("Save preferences ok");
        } catch (Exception ex) {
            ex.printStackTrace();
            Log.error("Error saving preferences: ");
        }
    }
//    public static void AddDirectory (String name){
//    String Directory = "./services/" + name + "/scripts/command/";
//
//    File NEW = new File(Directory);
//    if(!NEW.exists())
//    NEW.mkdirs();
//    }

    /**
     *     ,  ,     text
     * @param name
     * @author   dimax uin 963737
     */
    ////////////////////////////////////////////////////
    public static void AddTextService (String name){
    String Directory = "./text/" + name + "/help/";
    //String Svadba = "./text/" + name + "/Svadba/";

       File NEW = new File(Directory);
    if(!NEW.exists()){
    NEW.mkdirs();
        }
     // File NEW1 = new File(Svadba);
   // if(!NEW1.exists())
  //  NEW1.mkdirs();

    }
         public static void admin_msg(String services){
    try{
    new File("./text/" + services + "/admin_msg.txt").createNewFile();
    } catch (Exception ex){
    ex.printStackTrace();
    }
    }



     /**
     *  
     * @param name -  
     */
  public static synchronized void CopyingHelp(String name, String type){
  String[] files = null;
  if(type.equals("chat")){
  files = new String[8];
  files[0] = "osnova.txt";
  files[1] = "rank.txt";
  files[2] = "anketa.txt";
  files[3] = "users.txt";
  files[4] = "rooms.txt";
  files[5] = "fun.txt";
  files[6] = "admin.txt";
  files[7] = "system.txt";

  }
  try{
     for(int i=0; i < files.length; i++){
     InputStream stream = MainProps.class.getClassLoader().getResourceAsStream("ru/jimbot/" + type + "/help/" + files[i]);
     BufferedInputStream in = new BufferedInputStream(stream);
     BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream("./text/" + name+  "/help/" + files[i]));
          int len = 0, b = 0;
     while ((b = in.read()) != -1) {
        out.write(b);
        len += b;
     }
     in.close();
     out.flush();
     out.close();
     }
    } catch (Exception ex){
    Log.error("Errore copyring help - " + ex.getMessage());
    }
  }

   /**
     *  
     * @param name -  
     */
  public static synchronized void CopyingText(String name, String type){
  String[] files = null;
  if(type.equals("chat")){
  files = new String[2];
  files[0] = "rules.txt";
  files[1] = "Bytilochka.txt";
  }
  try{
     for(int i=0; i < files.length; i++){
     InputStream stream = MainProps.class.getClassLoader().getResourceAsStream("ru/jimbot/" + type + "/" + files[i]);
     BufferedInputStream in = new BufferedInputStream(stream);
     BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream("./text/" + name+  "/" + files[i]));
          int len = 0, b = 0;
     while ((b = in.read()) != -1) {
        out.write(b);
        len += b;
     }
     in.close();
     out.flush();
     out.close();
     }
    } catch (Exception ex){
    Log.error("Errore copyring text - " + ex.getMessage());
    }
  }



  /**
     *     URL
     * @param url
     * @return
     */
    public static String getStringFromHTTP(String u){
        String s = "";
        try {
            URL url = new URL(u);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestProperty ( "User-agent", "JimBot/0.4 (Java" +
                    "; U;" + System.getProperty("os.name") + " " + System.getProperty("os.arch") + " " + System.getProperty("os.version") +
                    "; ru; " + System.getProperty("java.vendor") + " " + System.getProperty("java.version") +
                    ")");
            BufferedInputStream bis = new BufferedInputStream(conn.getInputStream());
            byte[] b = new byte[1024];
            int count = 0;
            ByteArrayOutputStream bout = new ByteArrayOutputStream();
            while ((count=bis.read(b)) != -1)
                bout.write(b, 0, count);
            bout.close();
            bis.close();
            conn.disconnect();
            s = bout.toString("windows-1251");
        } catch (Exception ex) {
            Log.error(" HTTP    ", ex);
        }
        return s;
    }

public static synchronized void delMoveservices(String name){
       String Directory = "./trash/";
       File NEW = new File(Directory);
    if(!NEW.exists())
    NEW.mkdirs();
     String Directory1 = "./trash/"+name;
      File NEW1 = new File(Directory1);
    if(!NEW1.exists())
    NEW1.mkdirs();
  try{
File A = new File("./services/" + name + "/"  +  name + ".xml");
File B = new File("./trash/" +name+"/" + name + ".xml");
boolean b;
b = A.renameTo(B);
File c = new File("./services/" + name + "/amount.xml");
File d = new File("./trash/" +name+"/amount.xml");
boolean z;
z = c.renameTo(d);
 String Directory3 = "./services/"+name;
 File NEW3 = new File(Directory3);
    if(NEW3.exists())
    NEW3.delete();

    } catch (Exception ex){
    Log.error("Errore delservisemover - " + ex.getMessage());
    }
  }
     /**
     *     URL UTF-8
     * @param url
     * @return
     */
    public static String getStringFromHTTPutf(String u){
        String s = "";
        try {
            URL url = new URL(u);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestProperty ( "User-agent", "JimBot/0.4 (Java" +
                    "; U;" + System.getProperty("os.name") + " " + System.getProperty("os.arch") + " " + System.getProperty("os.version") +
                    "; ru; " + System.getProperty("java.vendor") + " " + System.getProperty("java.version") +
                    ")");
            BufferedInputStream bis = new BufferedInputStream(conn.getInputStream());
            byte[] b = new byte[1024];
            int count = 0;
            ByteArrayOutputStream bout = new ByteArrayOutputStream();
            while ((count=bis.read(b)) != -1)
                bout.write(b, 0, count);
            bout.close();
            bis.close();
            conn.disconnect();
            s = bout.toString("utf-8");
        } catch (Exception ex) {
            Log.error(" HTTP    ", ex);
        }
        return s;
    }

    /**
     *    
     * @return
     */
    public static boolean checkNewVersion() {
        if(!getBooleanProperty("main.checkNewVer")) return false;
        if(ver_no==0)
            readNewVer();
        if((System.currentTimeMillis()-ver_last_read)>24*3600000)
            readNewVer();
        return ver_no>VER_INT;
    }

    /**
     *    
     * @return
     */
    public static String getNewVerDesc() {
        return ver_desc;
    }

    /**
     *       
     */
    private static void readNewVer() {
        String s = getStringFromHTTP("http://nemo-chat.3dn.ru/mod.txt");
        ver_no = VER_INT;
        ver_desc = "";
        ver_last_read = System.currentTimeMillis();
        if(s.equals("")) return;
        try {
            BufferedReader r = new BufferedReader(new StringReader(s));
            String sd = r.readLine();
            if(!sd.equals("#JimBot version file")) return;
            ver_no = Integer.parseInt(r.readLine());
            String cnt = r.readLine();
            counter(cnt);
            if(ver_no>VER_INT)
                while(r.ready()){
                    String st = r.readLine();
                    if(st==null) break;
                    if(!st.equals(""))
                        if(Integer.parseInt(st.split("#")[0])==ver_no)
                            ver_desc += st.split("#")[1] + '\n';
                }
            r.close();
        } catch (Exception ex){
            Log.error("    ",ex);
        }
    }

    private static void counter(String s){
        try {
            String u = s.substring(8);
            u = u.replaceAll("@", "chat_ver=" + VERSION);
            u = u.replaceAll(" ", "%20");
            getStringFromHTTP(u);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void registerProperties(Properties _appProps) {
        appProps = _appProps;
    }

    public static String getProperty(String key) {
        return appProps.getProperty(key);
    }

    public static String getStringProperty(String key) {
        return appProps.getProperty(key);
    }

    public static String getProperty(String key, String def) {
        return appProps.getProperty(key,def);
    }

    public static void setProperty(String key, String val) {
        appProps.setProperty(key,val);
    }

    public static void setStringProperty(String key, String val) {
        appProps.setProperty(key,val);
    }

    public static void setIntProperty(String key, int val) {
        appProps.setProperty(key,Integer.toString(val));
    }

    public static void setBooleanProperty(String key, boolean val) {
        appProps.setProperty(key, val ? "true":"false");
    }

    public static int getIntProperty(String key) {
        return Integer.parseInt(appProps.getProperty(key));
    }

    public static boolean getBooleanProperty(String key) {
        return Boolean.valueOf(appProps.getProperty(key)).booleanValue();
    }

//************************************************************
/**
*   ip   
*/
public static void loadIgnorIPList(){
String s;
ignorIP = new HashSet<String>();
try{
BufferedReader r = new BufferedReader(new InputStreamReader(new FileInputStream("ignoreIP.txt"),"windows-1251"));
while (r.ready()){
s = r.readLine();
if(!s.equals("")){
ignorIP.add(s);
}
}
r.close();
} catch (Exception ex){
ex.printStackTrace();
}
}

public static String getType(String name){
for(int i=0; i<getServicesCount(); i++){
if(getServiceName(i).equals(name)) return getServiceType(i);
}
return null;
}

/**
* IP  ?
* @param uin
* @return
*/
public static boolean isIpIgnor(String uin){
if(ignorIP==null) return false;
return ignorIP.contains(uin);
}

public static int getUserCount(){
return getIntProperty("users.Count");
}

public static String getUserName(int i){
return getStringProperty("users.Name"+i);
}

public static String getUserPass(int i) {
return getStringProperty("users.Pass"+i);
}

public static String getUserService(int i) {
return getStringProperty("users.Service"+i);
}

public static String getUserIp(int i) {
return getStringProperty("users.ip"+i);
}

public static String getUserInTime(int i) {
return getStringProperty("users.inTume"+i);
}

/**
*  
* @param name
* @param pass
* @param service
* @return
*/
public static int addUser(String name, String pass, String service){
int c = getUserCount();
setIntProperty("users.Count", c+1);
setStringProperty("users.Name"+c, name);
setStringProperty("users.Pass"+c, pass);
setStringProperty("users.Service"+c, service);
setStringProperty("users.ip"+c, "");
setStringProperty("users.inTume"+c, "");
setStringProperty("users.Service_tmp"+c, "");
//copy_user(name);
return c;
}

/**
*   
* @param name
* @param pass
* @param services
*/
public static void changeUser(String name, String pass, String services){
Integer a = 0;
for(int i=0; i<(getUserCount()-1); i++){
if(getUserName(i).equals(name)) a = i;
}
setStringProperty("users.Pass"+a, pass);
setStringProperty("users.Service"+a, services);
setStringProperty("users.Service_tmp"+a, services);
}

public static void copy_user(String name){
Integer a = 0;
for(int i=0; i<(getUserCount()-1); i++){
if(getUserName(i).equals(name)) a = i;
}
setStringProperty("users.Service"+a, getStringProperty("users.Service_tmp"+a));
save();
}

/**
*   
* @param name
* @param pass
* @param services
*/
public static void changeUser_user(String name, String pass){
Integer a = 0;
for(int i=0; i<(getUserCount()-1); i++){
if(getUserName(i).equals(name)) a = i;
}
setStringProperty("users.Pass"+a, pass);
setStringProperty("users.Service"+a, getStringProperty("users.Service_tmp"+a));
}

/**
*    
* @param name
* @param pass
* @return
*/
public static boolean testAuth(String name, String pass){
Integer a = 0;
boolean f = false;
for(int i=0; i<getUserCount(); i++){
if(getUserName(i).equals(name)){
a = i;
f = true;
}
}
if(!f) return false;
if(getUserPass(a).trim().equals(pass.trim())) return true;
return false;
}

/**
*     
* @param name
* @param ip
* @param time
*/
public static void changeUser_ipAndTime(String name, String ip, String time){
Integer a = 0;
for(int i=0; i<getUserCount(); i++){
if(getUserName(i).equals(name)) a = i;
}
setStringProperty("users.ip"+a, ip);
setStringProperty("users.inTume"+a, time);
save();
}

/**
*   ?
* @param name
* @return
*/
public static boolean testUser(String name) {
for(int i=0; i<getUserCount(); i++){
if(getUserName(i).equals(name)) return true;
}
return false;
}

/**
*  
* @param name
*/
public static void delUser(String name) {
//       
boolean f = false;
for(int i=0; i<(getUserCount()-1); i++){
if(getUserName(i).equals(name))
f = true;
if(f){
setStringProperty("users.Name"+i, getUserName(i+1));
setStringProperty("users.Pass"+i, getUserPass(i+1));
setStringProperty("users.Service"+i, getUserService(i+1));
setStringProperty("users.ip"+i, getUserIp(i+1));
setStringProperty("users.inTume"+i, getUserInTime(i+1));
}
}
//   
appProps.remove("users.Name"+(getUserCount()-1));
appProps.remove("users.Pass"+(getUserCount()-1));
appProps.remove("users.Service"+(getUserCount()-1));
appProps.remove("users.ip"+(getUserCount()-1));
appProps.remove("users.inTume"+(getUserCount()-1));
appProps.remove("users.Service_tmp"+(getUserCount()-1));
setIntProperty("users.Count", getUserCount()-1);
}

public static void AddFail( String Type, String Way , String text  ) throws UnsupportedEncodingException {
try {
OutputStreamWriter NewFile = new OutputStreamWriter( new FileOutputStream( Way + "." + Type, true ), "windows-1251" );
NewFile.write( text );
NewFile.close();
}catch ( Exception ex ){
Log.error( "  : " , ex );
}
}


  public static void ObTextService (String name){
    String Directory = "./text/" + name;


       File NEW = new File(Directory);
    if(!NEW.exists()){
AddTextService(name);
admin_msg(name);
CopyingHelp(name, "chat");
CopyingText(name, "chat");

      }

    }





}
